package fr.itsee.season;

import android.os.Parcel;
import android.os.Parcelable;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

public class Commande implements Parcelable {

    private String num, nomClient, prenomClient, adresseClient, codePostalClient, villeClient, paysClient, date, webNomClient, webPrenomClient, webAdresseClient, webCodePostalClient, webVilleClient, webPaysClient, webTel1Client, webTel2Client, webMailClient, webStatutClient, raisonsocialeClient, lRaisonsocialeClient, commentaireClient, webCommentaireClient, telephoneClient, MCModePaiement;
    private int qtetotal;
    private double prixTotal, fraisDePortClient, montantTotalHTPaye;
    private String modeLivraison = "aucun";
    private List<Produit> listeProduit;

    public Commande(){
        this.listeProduit = new ArrayList<>();
    }

    protected Commande(Parcel in) {
        num = in.readString();
        nomClient = in.readString();
        date = in.readString();
        qtetotal = in.readInt();
        prixTotal = in.readDouble();
        modeLivraison = in.readString();
        listeProduit = in.readArrayList(Produit.class.getClassLoader());
        webPrenomClient = in.readString();
        webAdresseClient = in.readString();
        webCodePostalClient = in.readString();
        webVilleClient = in.readString();
        webTel1Client = in.readString();
        webTel2Client = in.readString();
        webMailClient = in.readString();
        webStatutClient = in.readString();
        prenomClient = in.readString();
        adresseClient = in.readString();
        codePostalClient = in.readString();
        villeClient = in.readString();
        webNomClient = in.readString();
        raisonsocialeClient = in.readString();
        lRaisonsocialeClient = in.readString();
        montantTotalHTPaye = in.readDouble();
        paysClient = in.readString();
        webPaysClient = in.readString();
        commentaireClient = in.readString();
        webCommentaireClient = in.readString();
        telephoneClient = in.readString();
        fraisDePortClient = in.readDouble();
        MCModePaiement = in.readString();
    }

    public static final Creator<Commande> CREATOR = new Creator<Commande>() {
        @Override
        public Commande createFromParcel(Parcel in) {
            return new Commande(in);
        }

        @Override
        public Commande[] newArray(int size) {
            return new Commande[size];
        }
    };

    public void addProduit(Produit p){
        listeProduit.add(0, p);
        incPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }

    public void delProduit(Produit p){
        listeProduit.remove(p);
        decPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }


    public void incPrixTotal(double n){
        this.prixTotal += n;
    }

    public void decPrixTotal(double n){
        this.prixTotal -= n;
    }

    public List<Produit> getListeProduit() {
        return listeProduit;
    }

    public String getModeLivraison() {
        return modeLivraison;
    }

    public String getDate() {
        return date;
    }

    public String getNum() {
        return num;
    }

    public int getQtetotal() {
        int cpt = 0;
        for (Produit p : listeProduit){
            cpt += p.getQte();
        }
        qtetotal = cpt;
        return qtetotal;
    }

    public String getNomClient() {
        return nomClient;
    }

    public String getPrenomClient() {
        return prenomClient;
    }

    public String getAdresseClient() {
        return adresseClient;
    }

    public String getCodePostalClient() {
        return codePostalClient;
    }

    public String getVilleClient() {
        return villeClient;
    }

    public String getPaysClient() { return paysClient; }

    public String getCommentaireClient() { return commentaireClient; }


    public double getPrixTotal() {
        double cpt = 0;
        for (Produit p : listeProduit){
            cpt += p.getPrixTotale();
        }
        prixTotal = cpt;
        return prixTotal;
    }

    public void setWebNomClient(String webNomClient) {
        this.webNomClient = webNomClient;
    }

    public String getWebNomClient() { return webNomClient; }

    public void setWebPrenomClient(String webPrenomClient) {
        this.webPrenomClient = webPrenomClient;
    }

    public String getWebPrenomClient() {
        return webPrenomClient;
    }

    public void setWebAdresseClient(String webAdresseClient) {
        this.webAdresseClient = webAdresseClient;
    }

    public String getWebAdresseClient() {
        return webAdresseClient;
    }

    public String getWebCodePostalClient() {
        return webCodePostalClient;
    }

    public void setWebCodePostalClient(String webCodePostalClient) {
        this.webCodePostalClient = webCodePostalClient;
    }

    public String getWebVilleClient() {
        return webVilleClient;
    }

    public void setWebVilleClient(String webVilleClient) {
        this.webVilleClient = webVilleClient;
    }

    public String getWebPaysClient() {
        return webPaysClient;
    }

    public void setWebPaysClient(String webPaysClient) {
        this.webPaysClient = webPaysClient;
    }

    public void setWebCommentaireClient(String webCommentaireClient) {
        this.webCommentaireClient = webCommentaireClient;
    }
    public String getWebCommentaireClient() { return webCommentaireClient; }

    public String getWebTel1Client() {
        return webTel1Client;
    }

    public void setWebTel1Client(String webTel1Client) {
        this.webTel1Client = webTel1Client;
    }

    public String getWebTel2Client() {
        return webTel2Client;
    }

    public void setWebTel2Client(String webTel2Client) {
        this.webTel2Client = webTel2Client;
    }

    public String getWebMailClient() {
        return webMailClient;
    }

    public void setWebMailClient(String webMailClient) {
        this.webMailClient = webMailClient;
    }

    public String getWebStatutClient() {
        return webStatutClient;
    }

    public String getRaisonsocialeClient() { return raisonsocialeClient; }

    public double getFraisDePortClient() { return fraisDePortClient; }

    public double getMontantTotalHTPaye() { return montantTotalHTPaye; }

    public String getTelephoneClient() { return telephoneClient; }

    public void setWebStatutClient(String webStatutClient) {
        this.webStatutClient = webStatutClient;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public void setNomClient(String nomClient) {
        this.nomClient = nomClient;
    }

    public void setPrenomClient(String prenomClient) {
        this.prenomClient = prenomClient;
    }

    public void setAdresseClient(String adresseClient) {
        this.adresseClient = adresseClient;
    }

    public void setCodePostalClient(String codePostalClient) { this.codePostalClient = codePostalClient; }

    public void setVilleClient(String villeClient) {
        this.villeClient = villeClient;
    }

    public void setPaysClient(String paysClient) {
        this.paysClient = paysClient;
    }

    public void setCommentaireClient(String commentaireClient) {
        this.commentaireClient = commentaireClient;
    }

    public void setNum(String num) {
        this.num = num;
    }

    public void setQtetotal(int qtetotal) {
        this.qtetotal = qtetotal;
    }

    public void setListeProduit(List<Produit> listeProduit) {
        this.listeProduit = listeProduit;
    }

    public void setModeLivraison(String modeLivraison) {
        this.modeLivraison = modeLivraison;
    }

    public void setPrixTotal(double prixTotal) {
        this.prixTotal = prixTotal;
    }

    public void setRaisonSocialeClient(String raisonsocialeClient) {this.raisonsocialeClient = raisonsocialeClient; }

    public void setlRaisonsocialeClient(String lRaisonsocialeClient) {this.lRaisonsocialeClient = lRaisonsocialeClient; }

    public void setFraisDePortClient(Double fraisDePortClient) {this.fraisDePortClient = fraisDePortClient; }

    public void setMontantTotalHTPaye(Double montantTotalHTPaye) { this.montantTotalHTPaye = montantTotalHTPaye; }

    public void setTelephoneClient(String telephoneClient) { this.telephoneClient = telephoneClient; }

    public String getLRaisonsocialeClient() { return lRaisonsocialeClient; }

    public void setMCModePaiement(String mcModePaiement) { this.MCModePaiement = mcModePaiement; }

    public String getMCModePaiement() { return MCModePaiement; }

    @Override
    public String toString() {
        return "" + num + ": " + listeProduit;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(num);
        parcel.writeString(nomClient);
        parcel.writeString(date);
        parcel.writeInt(qtetotal);
        parcel.writeDouble(prixTotal);
        parcel.writeString(modeLivraison);
        parcel.writeList(listeProduit);
        parcel.writeString(webPrenomClient);
        parcel.writeString(webAdresseClient);
        parcel.writeString(webCodePostalClient);
        parcel.writeString(webVilleClient);
        parcel.writeString(webTel1Client);
        parcel.writeString(webTel2Client);
        parcel.writeString(webMailClient);
        parcel.writeString(webStatutClient);
        parcel.writeString(prenomClient);
        parcel.writeString(adresseClient);
        parcel.writeString(codePostalClient);
        parcel.writeString(villeClient);
        parcel.writeString(webNomClient);
        parcel.writeString(raisonsocialeClient);
        parcel.writeString(lRaisonsocialeClient);
        parcel.writeDouble(montantTotalHTPaye);
        parcel.writeString(paysClient);
        parcel.writeString(webPaysClient);
        parcel.writeString(commentaireClient);
        parcel.writeString(webCommentaireClient);
        parcel.writeString(telephoneClient);
        parcel.writeDouble(fraisDePortClient);
        parcel.writeString(MCModePaiement);
    }

}
