package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.res.AssetFileDescriptor;
import android.graphics.Bitmap;
import android.graphics.Typeface;
import android.icu.text.DecimalFormat;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;

import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Html;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SearchView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;

import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.ScanDataCollection.ScanData;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.StatusData.ScannerStates;
import com.symbol.emdk.barcode.StatusData;

public class CommandesActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    /*public class CommandesActivity extends AppCompatActivity {*/

    private RecyclerView recyclerView;
    public static ProduitAdapter mAdapter;

    private TextView date, num, actifTab, previousTab, c1, c2, c3, mode, webCommandes, MCCommandes;
    public static TextView prixTotal, qteTotal;
    private SearchView searchBar;
    private EditText nom;
    private Button newC;

    public static String dernierNumeroCommandeWeb = "";
    public static String dernierNumeroCommandeMC = "";

    private int selectedTab = 1;

    public static Map<String, Bitmap> dicImages;
    public static List<Produit> listeAllProduits;
    public static List<Transporteur> listeAllTransporteurs;
    List<Commande> listeCommande = new ArrayList<>(3);
    public static Commande currentCommande;

    private Commande newCommande,newCommandeTab2,newCommandeTab3;
    private Commande commandeVide = new Commande();
    public static Commande commandeAImprimer = new Commande();

    public List<Produit> listeRupture;

    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;

    private TextView textViewData = null;
    private TextView textViewStatus = null;

    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13= null;
    private CheckBox checkBoxCode39= null;
    private CheckBox checkBoxCode128= null;

    private Spinner spinnerScannerDevices= null;

    private List<ScannerInfo> deviceList = null;

    private RecyclerView listeCommandes = null;

    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private int dataLength = 0;
    private String statusString = "";

    private boolean bSoftTriggerSelected = false;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private final Object lock = new Object();

    //Son
    private MediaPlayer mediaPlayer;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_commandes);

        //Permet de créer de nouvelles commandes automatiquement à minuit sauf le dimanche
        //Calcul de la prochaine exécution à minuit
        long actualTimeStamp = System.currentTimeMillis();
        Calendar c = new GregorianCalendar();
        c.add(Calendar.DATE, 1);
        c.set(Calendar.HOUR_OF_DAY, 0);
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        long tomorrowTimeStamp = c.getTimeInMillis();

        try {
            new GetAllTransporteursAsyncTask().execute();
            new GetAllProduitsAsyncTask().execute();
            new GetCheckCommandesWebAImprimerAsyncTask().execute();
            new GetCheckCommandesMCAImprimerAsyncTask().execute();
        }catch (Exception e){
            e.printStackTrace();
        }

        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        prixTotal = findViewById(R.id.prixTotal);
        searchBar = findViewById(R.id.bar_de_recherche);
        newC = findViewById(R.id.newC);
        qteTotal = findViewById(R.id.qteTotal);
        c1 = findViewById(R.id.c1);
        c2 = findViewById(R.id.c2);
        c3 = findViewById(R.id.c3);
        webCommandes = findViewById(R.id.commande_web_alerte);
        webCommandes.setVisibility(View.INVISIBLE);
        MCCommandes = findViewById(R.id.commande_mc_alerte);
        MCCommandes.setVisibility(View.INVISIBLE);
        mode = findViewById(R.id.mode);
        actifTab = c1;
        previousTab = null;
        actifTab.setTextColor(getResources().getColor(R.color.colorNoir));
        actifTab.setTypeface(null, Typeface.BOLD);

        dicImages = new HashMap<>();
        mAdapter = new ProduitAdapter( new Commande(), getApplicationContext());

        listeCommande.add(null);
        listeCommande.add(null);
        listeCommande.add(null);

        getListeCommandes();

        recyclerView = (RecyclerView) findViewById(R.id.recycler_view);
        textViewData = (TextView)findViewById(R.id.textViewData);
        textViewStatus = (TextView)findViewById(R.id.textViewStatus);
        checkBoxEAN8 = (CheckBox)findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = (CheckBox)findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = (CheckBox)findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = (CheckBox)findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = (Spinner)findViewById(R.id.spinnerScannerDevices);

        currentCommande = listeCommande.get(selectedTab - 1);

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);
        mAdapter.setOnItemClickListener(new ProduitAdapter.OnItemClickListener() {

            @Override
            public void onPhotoClik(int position) {
                Intent intent = new Intent(CommandesActivity.this, FicheProduitActivity.class);
                intent.putExtra("produit", getProduit(position));
                startActivityForResult(intent, 3);

            }

            @Override
            public void onSupprClick(int position) {
                currentCommande.delProduit(getProduit(position));
                mAdapter.notifyDataSetChanged();
                afficheCommande();
            }

            @Override
            public void onPlusClick(int position) {
                Produit p = getProduit(position);
                //actualisation du stock de ce produit direct en BDD
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();
                httpParams2.put("code_128", currentCommande.getListeProduit().get(position).getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        MainActivity.backOfficeURL + "getStockProduit.php", "GET", httpParams2);

                try {
                    int success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        p.setStock(Integer.parseInt(produit.getString("stock")));
                        currentCommande.getListeProduit().get(position).setStock(Integer.parseInt(produit.getString("stock")));
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                int reste = p.getStock() - p.getQte()-1;

                if (reste <= 1 && reste > 0){
                    //20230620, on laisse quand même on ne sait jamais
                    p.incQte();
                    Toast.makeText(getApplicationContext(), "Stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "Stock épuisé!", Toast.LENGTH_SHORT).show();
                    p.incQte();
                }else if (reste < -2){ // MODIF ITSEE 20190701 16:16 transforme == -2 vers < -2
                    Toast.makeText(getApplicationContext(), "Stock négatif!", Toast.LENGTH_SHORT).show();
                    p.incQte();
                }
                else{
                    p.incQte();
                }
                afficheCommande();
            }

            @Override
            public void onMoinsClick(int position) {
                Produit p = getProduit(position);
                //actualisation du stock de ce produit direct en BDD
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();
                httpParams2.put("code_128", currentCommande.getListeProduit().get(position).getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        MainActivity.backOfficeURL + "getStockProduit.php", "GET", httpParams2);

                try {
                    int success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        p.setStock(Integer.parseInt(produit.getString("stock")));
                        currentCommande.getListeProduit().get(position).setStock(Integer.parseInt(produit.getString("stock")));
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                if (p.getQte() == 1){
                    currentCommande.delProduit(getProduit(position));
                }else{
                    currentCommande.getListeProduit().get(position).decQte();
                }
                afficheCommande();
            }

            @Override
            public void onQuantiteClick(int position) {
                DialogCommandesActivityEditQte.show(CommandesActivity.this, position);
            }
        });


        searchBar.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                searchBar.clearFocus();
                if (CommandesActivity.listeAllProduits != null) {
                    Intent intent = new Intent(CommandesActivity.this, RechercheActivity.class);
                    intent.putExtra("recherche", s);
                    startActivityForResult(intent, 4);
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                return false;
            }
        });

        currentCommande = listeCommande.get(selectedTab - 1);

        if (currentCommande != null){
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }

        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }

        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();
        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());


        nom.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                currentCommande.setNomClient(String.valueOf(textView.getText()));
                return false;
            }
        });

        nom.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean b) {
                currentCommande.setNomClient(String.valueOf(((EditText)view).getText()));
            }
        });

        new Timer().scheduleAtFixedRate(new TimerTask() {
            @Override
            public void run() {
                new GetCheckCommandesWebAImprimerAsyncTask().execute();
                new GetCheckCommandesMCAImprimerAsyncTask().execute();
            }
        }, 0, 120000);//put here time 1000 milliseconds=1 second

    }

    public Produit getProduit(int position){
        return currentCommande.getListeProduit().get(position);
    }

    public void changetab(View v){
        previousTab = actifTab;
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setTypeface(null, Typeface.NORMAL);
        actifTab = ((TextView)v);
        actifTab.setTextColor(getResources().getColor(R.color.colorNoir));
        actifTab.setTypeface(null, Typeface.BOLD);
        selectedTab = Integer.parseInt(actifTab.getText().toString());

        if (listeCommande.get(selectedTab - 1) == null){
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }
        else{
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeCommandes();
    }

    public void saveListeCommandes(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeCommande",gson.toJson(listeCommande)).apply();
    }

    public void getListeCommandes(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeCommande",null);

        if(json != null){
            listeCommande = gson.fromJson(json,new TypeToken<List<Commande>>() {}.getType());
        }
    }

    public void afficheCommande(){
        currentCommande = listeCommande.get(selectedTab - 1);

        if (currentCommande != null){
            date.setText("Date: " + currentCommande.getDate());
            num.setText("N°: " + currentCommande.getNum());
            mode.setText(currentCommande.getModeLivraison());
            nom.setEnabled(true);
            if (currentCommande.getNomClient().equals("")){
                nom.setText("");
            }else{
                nom.setText(currentCommande.getNomClient());
            }
            DecimalFormat df = new DecimalFormat("0.00");
            prixTotal.setText(""+df.format(currentCommande.getPrixTotal()));
            if (currentCommande.getQtetotal() > 1) {
                qteTotal.setText(String.valueOf(currentCommande.getQtetotal()) + " packs");
            } else {
                qteTotal.setText(String.valueOf(currentCommande.getQtetotal()) + " pack");
            }
            mAdapter.notifyDataSetChanged();
        }else{
            date.setText("");
            num.setText("");
            mode.setText("aucun");
            nom.setText("");
            nom.setEnabled(false);
            prixTotal.setText("0,00");
            qteTotal.setText("0 pack");
            mAdapter.notifyDataSetChanged();
        }
    }

    public void imprimerCommande(View v){
        if (currentCommande != null){
            //new RefreshStockAsyncTask().execute();
            if (!currentCommande.getModeLivraison().equals("aucun")){
                if (currentCommande.getListeProduit().size() > 0){
                    new VerifStockAsyncTask().execute();
                }else{
                    Toast.makeText(getApplicationContext(), "La commande est vide", Toast.LENGTH_SHORT).show();
                }
            }else{
                Toast.makeText(getApplicationContext(), "Aucun mode de livraison choisi", Toast.LENGTH_SHORT).show();
            }
        }else {
            Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        if (netInfo != null && netInfo.isConnectedOrConnecting()) {
            return true;
        } else {
            return false;
        }
    }

    public void nouvelleCommande(View v){

        if (isOnline()){

            if (currentCommande != null){
                DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        switch (which){
                            case DialogInterface.BUTTON_POSITIVE:
                                //Annulation
                                dialog.dismiss();
                                break;

                            case DialogInterface.BUTTON_NEGATIVE:
                                //Terminer
                                DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                                Date date = new Date();
                                newCommande = new Commande();
                                newCommande.setNomClient("");
                                newCommande.setDate(dateFormat.format(date));
                                newCommande.setQtetotal(0);
                                newCommande.setPrixTotal(0);
                                newCommande.setModeLivraison("aucun");
                                new AddCommandeAsyncTask().execute();
                                dialog.dismiss();
                                break;
                        }
                    }
                };
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle("Voulez-vous terminer la commande ?");
                builder.setMessage("Vous ne pourrez plus changer cette commande.");
                builder.setPositiveButton("Annuler", dialogClickListener);
                builder.setNegativeButton("Terminer", dialogClickListener);
                builder.show();
            }else{
                DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                Date date = new Date();
                newCommande = new Commande();
                newCommande.setNomClient("");
                newCommande.setDate(dateFormat.format(date));
                newCommande.setQtetotal(0);
                newCommande.setPrixTotal(0);
                newCommande.setModeLivraison("aucun");

                new AddCommandeAsyncTask().execute();
            }
        }else{
            Toast.makeText(getApplicationContext(), "Connexion au back office impossible", Toast.LENGTH_SHORT).show();
        }
    }

    public static Produit getProduitInCommande(String code128){
        for (Produit pr : currentCommande.getListeProduit()){
            if (pr.getCode128().equals(code128)){
                return pr;
            }
        }
        return null;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 1) {
            if(resultCode == Activity.RESULT_OK){
                Commande newC = data.getParcelableExtra("newC");
                listeCommande.set(selectedTab - 1, newC);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(currentCommande);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
            }else if (resultCode == Activity.RESULT_CANCELED) {
                if (listeCommande.get(0) == null && listeCommande.get(1) == null && listeCommande.get(2) == null && previousTab == null){
                    finish();
                }
                else{
                    previousTab.callOnClick();
                }
            }
        } else if (requestCode == 2) {
            if(resultCode == Activity.RESULT_OK){
                String choix = data.getStringExtra("choix");
                String choixNom = data.getStringExtra("choixNom");
                Integer posTransporteur = 0;
                switch (choixNom) {
                    case "fr.itsee.season:id/m1":
                        posTransporteur = 0;
                        break;
                    case "fr.itsee.season:id/m4":
                        posTransporteur = 1;
                        break;
                    case "fr.itsee.season:id/m2":
                        posTransporteur = 2;
                        break;
                    case "fr.itsee.season:id/m5":
                        posTransporteur = 3;
                        break;
                    case "fr.itsee.season:id/m3":
                        posTransporteur = 4;
                        break;
                    case "fr.itsee.season:id/m6":
                        posTransporteur = 5;
                        break;
                    case "fr.itsee.season:id/m8":
                        posTransporteur = 6;
                        break;
                    case "fr.itsee.season:id/m7":
                        posTransporteur = 7;
                        break;
                    case "fr.itsee.season:id/m10":
                        posTransporteur = 8;
                        break;
                    case "fr.itsee.season:id/m9":
                        posTransporteur = 9;
                        break;
                    default:
                        break;
                }
                //Attribuer le prix du transporteur
                if (choix != "aucun") {
                    currentCommande.setFraisDePortClient(listeAllTransporteurs.get(posTransporteur).getPrix());
                    currentCommande.setModeLivraison(listeAllTransporteurs.get(posTransporteur).getNom());
                } else {
                    currentCommande.setFraisDePortClient(0.00);
                    currentCommande.setModeLivraison("aucun");
                }
                mode.setText(currentCommande.getModeLivraison());

            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 3) {
            if(resultCode == Activity.RESULT_OK){
                Produit p = data.getParcelableExtra("produit");
                ajouterProduitCommande(p.getCode128());
            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 4) {
            if(resultCode == Activity.RESULT_OK){
                if (currentCommande != null){
                    Produit p = data.getParcelableExtra("produit");
                    ajouterProduitCommande(p.getCode128());
                }else{
                    Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                }

            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
            //20230603 - RETOUR IMPRESSION COMMANDE
        } else if (requestCode == 100) {
            if(resultCode == Activity.RESULT_OK){
                //20230604 - Si l'impression s'est bien déroulée, alors on efface la commande actuelle
                listeCommande.set(selectedTab - 1, null);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(commandeVide);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
                //Lancer directement une nouvelle commande
                newC.callOnClick();
            } else if (resultCode == Activity.RESULT_CANCELED) {
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Echec d'impression");
                String msg = "Souhaitez-vous relancer ?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //Relancer l'impression
                                Intent intent = new Intent(CommandesActivity.this, PrinterActivity.class);
                                intent.putExtra("commande", currentCommande);
                                //startActivity(intent);
                                startActivityForResult(intent, 100);
                                dialog.dismiss();
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //20230604 - On ne souhaite pas lancer l'impression, alors on efface la commande actuelle
                                listeCommande.set(selectedTab - 1, null);
                                currentCommande = listeCommande.get(selectedTab - 1);
                                mAdapter.setCmd(commandeVide);
                                recyclerView.setAdapter(mAdapter);
                                afficheCommande();
                                //Lancer directement une nouvelle commande
                                newC.callOnClick();
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
            //20230603 - RETOUR IMPRESSION COMMANDE WEB
        }  else if (requestCode == 200) {
            if(resultCode == Activity.RESULT_OK){
            } else if (resultCode == Activity.RESULT_CANCELED) {
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Echec d'impression");
                String msg = "Souhaitez-vous retenter ?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //DialogCommandesActivityListWebCommandes.show(CommandesActivity.this, 0);
                                //Lancement de l'impression WEB
                                Intent intent = new Intent(CommandesActivity.this, PrinterWebActivity.class);
                                intent.putExtra("commande", commandeAImprimer);
                                //mActivity.startActivity(intent);
                                startActivityForResult(intent, 200);
                                //Fermer le popup
                                dialog.dismiss();
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
            // 20230603 - RETOUR IMPRESSION COMMANDE MC
        }   else if (requestCode == 300) {
            if(resultCode == Activity.RESULT_OK){
            } else if (resultCode == Activity.RESULT_CANCELED) {
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Echec d'impression");
                String msg = "Souhaitez-vous retenter ?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //DialogCommandesActivityListMCCommandes.show(CommandesActivity.this, 0);
                                //Lancement de l'impression MC
                                Intent intent = new Intent(CommandesActivity.this, PrinterMCActivity.class);
                                intent.putExtra("commande", commandeAImprimer);
                                //mActivity.startActivity(intent);
                                startActivityForResult(intent, 300);
                                //Fermer le popup
                                dialog.dismiss();
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
        }

    }

    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (isOnline()) {
            try {
                new GetAllTransporteursAsyncTask().execute();
                new GetAllProduitsAsyncTask().execute();
                new GetCheckCommandesWebAImprimerAsyncTask().execute();
                new GetCheckCommandesMCAImprimerAsyncTask().execute();
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();

    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeCommandes();
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList <ScanData> scanData = scanDataCollection.getScanData();
            for(ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch(state) {
            case IDLE:
                statusString = statusData.getFriendlyName()+" is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if(bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if(bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if(!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName()+" is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    public void onWebCommandes(View v) {
        DialogCommandesActivityListWebCommandes.show(CommandesActivity.this, 0);
    }

    public void onMCCommandes(View v) {
        DialogCommandesActivityListMCCommandes.show(CommandesActivity.this, 0);
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch(connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
        else {
            bExtScannerDisconnected = false;
            status =  statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            }
            else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            }else{
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try{
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try{
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager(){
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager(){
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner==null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while(it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if(scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(CommandesActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled= checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead(){
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    Produit p = getProduitFromCode128(result);
                    if (getCurrentFocus().getClass().getSimpleName().equals("SearchAutoComplete")){
                        if (p != null && currentCommande != null){
                            Intent intent = new Intent(CommandesActivity.this, FicheProduitActivity.class);
                            intent.putExtra("produit", p);
                            startActivityForResult(intent, 3);
                            searchBar.clearFocus();
                        }else if (currentCommande == null){
                            Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                        }else if(p == null){
                            jouerSon("erreurProduit.mp3");
                            Toast.makeText(CommandesActivity.this, "Produit inexistant!", Toast.LENGTH_SHORT).show();
                        }
                    }else{
                        if (p != null && currentCommande != null){
                            ajouterProduitCommande(p.getCode128());
                        }else if (currentCommande == null){
                            Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                        }else if(p == null){
                            jouerSon("erreurProduit.mp3");
                            Toast.makeText(CommandesActivity.this, "Produit inexistant!", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            }
        });
    }

    public Produit getProduitFromCode128(String code128){
        try {
            //Contrôler le stock uniquement lors de l'ajout d'un produit
            new RefreshStockAsyncTask().execute();

            for (Produit p : listeAllProduits){
                if(p.getCode128().equals(code128)){
                    return p;
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public void ajouterProduitCommande(String code128){
        int i = 0;
        int max = listeAllProduits.size();
        while ( !listeAllProduits.get(i).getCode128().equals(code128) && i < max - 1){
            i += 1;
        }
        if (i < max){//si le produit existe dans la base de donnees
            int j = 0;
            int nbrProduitCommande = currentCommande.getListeProduit().size();
            Produit p = listeAllProduits.get(i);

            new RefreshProduitAsyncTask().execute(p);

            while ( nbrProduitCommande > 0 && !currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128()) && j < nbrProduitCommande - 1){
                j += 1;
            }

            int qte;
            if (currentCommande.getListeProduit().size() != 0){
                qte = currentCommande.getListeProduit().get(j).getQte();
            }else{
                qte = 0;
            }

            int reste = p.getStock() - qte-1;

            if (j != nbrProduitCommande && nbrProduitCommande != 0 && currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128())){
                if (reste <= 1 && reste > 0){
                    jouerSon("erreurProduit.mp3");
                    currentCommande.getListeProduit().get(j).incQte();
                    Toast.makeText(getApplicationContext(), "stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "stock épuisé!", Toast.LENGTH_SHORT).show();
                    currentCommande.getListeProduit().get(j).incQte();
                }else if (reste < -2){ //CHANGEMENT ITSEE 20190630 21:31 changement == -2 vers < -2
                    currentCommande.getListeProduit().get(j).incQte();
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "stock négatif!", Toast.LENGTH_SHORT).show();
                }
                else{
                    currentCommande.getListeProduit().get(j).incQte();
                }
            }
            else{
                if (reste <= 1 && reste > 0){
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "Stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "Stock épuisé!", Toast.LENGTH_SHORT).show();
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                }else if (reste < -2){  // MODIF ITSEE 20190701 16:18 == -2 vers < -2
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                    jouerSon("erreurProduit.mp3");
                    Toast.makeText(getApplicationContext(), "Stock négatif!", Toast.LENGTH_SHORT).show();
                }
                else{
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                }
            }
            afficheCommande();
        }
        else{
            jouerSon("erreurProduit.mp3");
            Toast.makeText(getApplicationContext(), "PRODUIT INEXISTANT", Toast.LENGTH_SHORT).show();
        }
    }


    public void choixModeLivraison(View v){
        if (currentCommande != null){
            Intent intent = new Intent(CommandesActivity.this, ModeLivraisonActivity.class);
            intent.putExtra("commande", currentCommande);
            startActivityForResult(intent, 2);
        }else {
            Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    private void checkCommande(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if(dataLength ++ > 100) { //Clear the cache after 100 scans
                        textViewData.setText("");
                        dataLength = 0;
                    }
                    textViewData.append(Html.fromHtml(result));
                    textViewData.append("\n");
                    ((View) findViewById(R.id.scrollViewData)).post(new Runnable()
                    {
                        public void run()
                        {
                            ((ScrollView) findViewById(R.id.scrollViewData)).fullScroll(View.FOCUS_DOWN);
                        }
                    });
                }
            }
        });
    }

    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //CHECKER SI NOUVELLES COMMANDES WEB
    private class GetCheckCommandesWebAImprimerAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... strings) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "cptListeNumeroCommandesWebNonImprimee.php", "GET", null);
            JSONArray cptWebCommandesData;
            try {
                int success = jsonObject.getInt("success");
                if (success == 1) {
                    cptWebCommandesData = jsonObject.getJSONArray("data");
                    JSONObject cptWebCommandesRes = cptWebCommandesData.getJSONObject(0);
                    Integer cptWebCommandes = cptWebCommandesRes.getInt("cptCommandes");
                    if (cptWebCommandes != 0) {
                        return "oui";
                    } else {
                        return "non";
                    }
                } else {
                    return "non";
                }
            }
            catch (JSONException e) {
                e.printStackTrace();
            }catch (Exception e){
                e.printStackTrace();
            }
            return "non";
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s == "oui") {
                webCommandes.setVisibility(View.VISIBLE);
            } else {
                webCommandes.setVisibility(View.INVISIBLE);
            }
        }

    }

    //CHECKER SI NOUVELLES COMMANDES MC
    private class GetCheckCommandesMCAImprimerAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... strings) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "cptListeNumeroCommandesMCNonImprimee.php", "GET", null);
            JSONArray cptMCCommandesData;
            try {
                int success = jsonObject.getInt("success");
                if (success == 1) {
                    cptMCCommandesData = jsonObject.getJSONArray("data");
                    JSONObject cptMCCommandesRes = cptMCCommandesData.getJSONObject(0);
                    Integer cptMCCommandes = cptMCCommandesRes.getInt("cptCommandes");
                    if (cptMCCommandes != 0) {
                        return "oui";
                    } else {
                        return "non";
                    }
                } else {
                    return "non";
                }
            }
            catch (JSONException e) {
                e.printStackTrace();
            }catch (Exception e){
                e.printStackTrace();
            }
            return "non";
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s == "oui") {
                MCCommandes.setVisibility(View.VISIBLE);
            } else {
                MCCommandes.setVisibility(View.INVISIBLE);
            }
        }

    }


    //BASE DE DONNES
    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduits.php", "GET", null);
            List<Produit> produitList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    for (int i = 0; i < produits.length(); i++) {
                        Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);

                        try {
                            p.setRef(produit.getString("reference"));
                            p.setColoris(produit.getString("coloris"));
                            p.setCommandable(produit.getString("commandable"));
                            p.setCode128(produit.getString("code_128"));
                            p.setQuantite_pack(produit.getInt("quantite_packs"));
                            p.setPrix(produit.getDouble("prix"));
                            p.setStock(produit.getInt("stock"));
                            p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                            p.setInformations(produit.getString("informations"));
                            p.setLien_image(produit.getString("lien_image"));
                            p.setActif(produit.getInt("actif"));
                            p.setQte(1);
                            produitList.add(p);

                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }
                    CommandesActivity.listeAllProduits = produitList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }


    private class UpdateCommandeAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser1 = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("num_commande", currentCommande.getNum());

            JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                    BASE_URL + "viderCommande.php", "POST", httpParams1);
            try {
                success = jsonObject1.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("num_commande", currentCommande.getNum());

            for(Produit p : currentCommande.getListeProduit()){

                httpParams.put("code128_produit", p.getCode128());
                httpParams.put("quantite", String.valueOf(p.getQte()));
                httpParams.put("prix", String.valueOf(p.getPrix()));
                httpParams.put("quantite_pack", String.valueOf(p.getQuantite_pack()));

                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "ajoutProduitCommande.php", "POST", httpParams);
                try {
                    success = jsonObject.getInt("success");
                } catch (JSONException e) {

                    e.printStackTrace();
                }

            }

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("numero_commande", currentCommande.getNum());
            httpParams2.put("nom_client", currentCommande.getNomClient());
            httpParams2.put("mode_livraison", currentCommande.getModeLivraison());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "updateCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    private class DestockageProduitAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        ProgressDialog waiting;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Impression en cours ...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

            new UpdateCommandeAsyncTask().execute();

            //Impression à la fin
        }

        @Override
        protected String doInBackground(String... params) {

            if (currentCommande != null) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();

                //On forme le json à envoyer
                for(Produit p : currentCommande.getListeProduit()){

                    httpParams.put("code128_produit", p.getCode128());
                    httpParams.put("quantite", String.valueOf(p.getQte()));

                    JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                            BASE_URL + "destockageProduit.php", "POST", httpParams);
                    try {
                        success = jsonObject.getInt("success");
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }

            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //waiting.dismiss();

            /*waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Enregistrement des produits de la commande");
            waiting.setMessage("Veuillez patienter");
            waiting.show();
*/
            //Lance l'impression en appelant la classe PrinterActivity remplacé par PrinterAsync
            Intent intent = new Intent(CommandesActivity.this, PrinterActivity.class);
            intent.putExtra("commande", currentCommande);
            //startActivity(intent);
            startActivityForResult(intent, 100);

            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }

            //20230604 - DEPLACE DANS LE RETOUR DE L'IMPRESSION DE LA COMMANDE
            //SI L'IMPRESSION NE S'EST PAS PASSE, ALORS ON NE FAIT RIEN
            /*listeCommande.set(selectedTab - 1, null);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
            //Lancer directement une nouvelle commande
            newC.callOnClick();*/
        }
    }

    private class RefreshProduitAsyncTask extends AsyncTask<Produit, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected String doInBackground(Produit... produits) {
            Produit p = produits[0];

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("code_128", p.getCode128());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "getStockProduit.php", "GET", httpParams2);

            try {
                success = jsonObject2.getInt("success");
                if (success == 1){
                    JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                    p.setStock(Integer.parseInt(produit.getString("stock")));
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
        }
    }



    private class RefreshStockAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            //waiting = new ProgressDialog(CommandesActivity.this);
            //waiting.setTitle("Contrôle du stock des produits en cours...");
            //waiting.setMessage("Veuillez patienter");
            //waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                for (Produit p : currentCommande.getListeProduit()){
                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();

                    httpParams2.put("code_128", p.getCode128());
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "getStockProduit.php", "GET", httpParams2);

                    try {
                        success = jsonObject2.getInt("success");
                        if (success == 1){
                            JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                            p.setStock(Integer.parseInt(produit.getString("stock")));
                        }

                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
            //waiting.dismiss();
        }
    }
    private class AddCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        private ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Création de la commande en cours...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

        }

        @Override
        protected String doInBackground(String... params) {

            DateFormat dateFormatForNumCommande = new SimpleDateFormat("yyMMdd");
            Date date = new Date();

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("date", newCommande.getDate());
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeCommandeDate.php", "GET", httpParams);
            int nbrCommandeParDate = 0;
            try {
                int success = jsonObject.getInt("success");
                int nbrCommandesAjd;

                if (success == 1) {
                    nbrCommandesAjd = jsonObject.getInt("data");
                    nbrCommandeParDate = nbrCommandesAjd;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }

            newCommande.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();
            //Populating request parameters
            httpParams2.put("numero_commande", newCommande.getNum());
            httpParams2.put("nom_client", "");
            httpParams2.put("date_commande", newCommande.getDate());
            httpParams2.put("zone", "0");
            httpParams2.put("complete", "0");
            httpParams2.put("mode_livraison", newCommande.getModeLivraison());

            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "ajouterCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
            listeCommande.set(selectedTab - 1, newCommande);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();

        }
    }

    private class AddCommandeAsyncTaskAllTabs extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {

            DateFormat dateFormatForNumCommande = new SimpleDateFormat("yyMMdd");
            Date date = new Date();
            Calendar cal = Calendar.getInstance();
            if (cal.get(Calendar.DAY_OF_WEEK) != Calendar.SUNDAY) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();
                httpParams.put("date", newCommande.getDate());
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeCommandeDate.php", "GET", httpParams);
                int nbrCommandeParDate = 0;
                try {
                    int success = jsonObject.getInt("success");
                    int nbrCommandesAjd;

                    if (success == 1) {
                        nbrCommandesAjd = jsonObject.getInt("data");
                        nbrCommandeParDate = nbrCommandesAjd;
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                newCommande.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();
                //Populating request parameters
                httpParams2.put("numero_commande", newCommande.getNum());
                httpParams2.put("nom_client", "");
                httpParams2.put("date_commande", newCommande.getDate());
                httpParams2.put("zone", "0");
                httpParams2.put("complete", "0");
                httpParams2.put("mode_livraison", newCommande.getModeLivraison());

                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "ajouterCommande.php", "POST", httpParams2);
                try {
                    int success = jsonObject2.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }


                //TAB2
                jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeCommandeDate.php", "GET", httpParams);
                nbrCommandeParDate = 0;
                try {
                    int success = jsonObject.getInt("success");
                    int nbrCommandesAjd;

                    if (success == 1) {
                        nbrCommandesAjd = jsonObject.getInt("data");
                        nbrCommandeParDate = nbrCommandesAjd;
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                newCommandeTab2.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

                //Populating request parameters
                httpParams2.put("numero_commande", newCommandeTab2.getNum());
                httpParams2.put("nom_client", "");
                httpParams2.put("date_commande", newCommandeTab2.getDate());
                httpParams2.put("zone", "0");
                httpParams2.put("complete", "0");
                httpParams2.put("mode_livraison", newCommandeTab2.getModeLivraison());

                jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "ajouterCommande.php", "POST", httpParams2);
                try {
                    int success = jsonObject2.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                //TAB 3
                jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeCommandeDate.php", "GET", httpParams);
                nbrCommandeParDate = 0;
                try {
                    int success = jsonObject.getInt("success");
                    int nbrCommandesAjd;

                    if (success == 1) {
                        nbrCommandesAjd = jsonObject.getInt("data");
                        nbrCommandeParDate = nbrCommandesAjd;
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                newCommandeTab3.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

                //Populating request parameters
                httpParams2.put("numero_commande", newCommandeTab3.getNum());
                httpParams2.put("nom_client", "");
                httpParams2.put("date_commande", newCommandeTab3.getDate());
                httpParams2.put("zone", "0");
                httpParams2.put("complete", "0");
                httpParams2.put("mode_livraison", newCommande.getModeLivraison());

                jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "ajouterCommande.php", "POST", httpParams2);
                try {
                    int success = jsonObject2.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            Calendar cal = Calendar.getInstance();
            if (cal.get(Calendar.DAY_OF_WEEK) != Calendar.SUNDAY) {
                //TAB3
                listeCommande.set(2, newCommandeTab3);
                //currentCommande = listeCommande.get(2);
                //mAdapter.setCmd(currentCommande);
                //recyclerView.setAdapter(mAdapter);
                //afficheCommande();
                //TAB2
                listeCommande.set(1, newCommandeTab2);
                //currentCommande = listeCommande.get(1);
                //mAdapter.setCmd(currentCommande);
                //recyclerView.setAdapter(mAdapter);
                //afficheCommande();
                //TAB1
                listeCommande.set(0, newCommande);
                currentCommande = listeCommande.get(0);
                mAdapter.setCmd(currentCommande);
                recyclerView.setAdapter(mAdapter);
                selectedTab = 1; //Affiche la tab 1 par défaut
                afficheCommande();
            }
        }
    }


    private class VerifStockAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Impression en cours...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            listeRupture = new ArrayList<>();

            for (Produit p : currentCommande.getListeProduit()){
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();

                httpParams2.put("code_128", p.getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "getStockProduit.php", "GET", httpParams2);

                try {
                    success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        p.setStock(Integer.parseInt(produit.getString("stock")));
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }
                if (p.getStock() - p.getQte() < -1){
                    listeRupture.add(p);
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (listeRupture.size() == 0){
                //Lancement de l'application
                //Lancement du déstockage
                new DestockageProduitAsyncTask().execute();
            }else{
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Rupture de stock");
                String msg = "Les produits suivants ont un stock insuffisant, vous devez réduire leurs quantités ou les enlever de la commande.\n\n";
                for (Produit p : listeRupture){
                    if (p.getStock() > 1) {
                        msg += p.getCode128() + " (" + p.getStock() + " restants)\n";
                    } else {
                        msg += p.getCode128() + " (" + p.getStock() + " restant)\n";
                    }
                }
                builder.setMessage(msg);
                builder.setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
        }
    }

    private class GetAllTransporteursAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeTransporteurs.php", "GET", null);
            List<Transporteur> transporteursList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray transporteurs;
                if (success == 1) {
                    transporteurs = jsonObject.getJSONArray("data");
                    for (int i = 0; i < transporteurs.length(); i++) {
                        Transporteur t = new Transporteur();
                        JSONObject transporteur = transporteurs.getJSONObject(i);
                        try {
                            t.setNom(transporteur.getString("nom"));
                            t.setPrix(transporteur.getDouble("prix"));
                            transporteursList.add(t);
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                    listeAllTransporteurs = transporteursList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

    void jouerSon(String filename) {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd(filename);
            if (filename != "erreurProduit.mp3") {
                mediaPlayer.setVolume(0.2f,0.2f);
            } else {
                mediaPlayer.setVolume(1.0f,1.0f);
            }
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(mp -> mp.start());
        //Release après lecture
        mediaPlayer.setOnCompletionListener(mp -> {
            if (mp != null) {
                mp.release();
            }
        });
    }

}