package fr.itsee.season;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.res.AssetFileDescriptor;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Bundle;

import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.StatusData;

import static fr.itsee.season.CommandesActivity.dicImages;
import static fr.itsee.season.CommandesActivity.listeAllProduits;

public class ControleActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    //public class ControleActivity extends AppCompatActivity {

    private RecyclerView recyclerView;
    private ProduitAdapterControle mAdapter;

    private TextView date, num, nom, qteTotal, actifTab, c1, c2, c3;

    private int selectedTab = 1;


    List<Commande> listeControle = new ArrayList<>(3);


    List<List<Produit>> listeDeListeAScanner = new ArrayList<>(3);

    public static Commande currentControle;
    public static List<Produit> currentListeAScanner;

    private List<Produit> listeVide;

    private String code128;

    //Partie Scanner

    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;

    private TextView textViewData = null;
    private TextView textViewStatus = null;

    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13= null;
    private CheckBox checkBoxCode39= null;
    private CheckBox checkBoxCode128= null;

    private Spinner spinnerScannerDevices= null;

    private List<ScannerInfo> deviceList = null;

    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private String statusString = "";

    private boolean bSoftTriggerSelected = false;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private final Object lock = new Object();

    //Son
    private MediaPlayer mediaPlayer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_controle);

        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        qteTotal = findViewById(R.id.qteTotal);
        if (dicImages == null){
            dicImages = new HashMap<>();
            new GetAllProduitsAsyncTask().execute();
        }


        mAdapter = new ProduitAdapterControle(new ArrayList<Produit>(), getApplicationContext());

        listeControle.add(null);
        listeControle.add(null);
        listeControle.add(null);

        listeVide = new ArrayList<>();

        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);

        getListeControles();
        getListeDeListeAScanner();

        recyclerView = (RecyclerView) findViewById(R.id.recycler_view);
        textViewData = (TextView)findViewById(R.id.textViewData);
        textViewStatus = (TextView)findViewById(R.id.textViewStatus);
        checkBoxEAN8 = (CheckBox)findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = (CheckBox)findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = (CheckBox)findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = (CheckBox)findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = (Spinner)findViewById(R.id.spinnerScannerDevices);


        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);


        currentControle = listeControle.get(selectedTab - 1);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);


        if (currentControle == null){
            afficheVide();
        }else{
            mAdapter.setListeProduit(currentListeAScanner);
            recyclerView.setAdapter(mAdapter);
            afficheControle();
        }

        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }

        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();

        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());

    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeControles();
        saveListeDeListeAScanner();
    }


    public void saveListeControles(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeControle",gson.toJson(listeControle)).apply();
    }

    public void getListeControles(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeControle",null);

        if(json != null){
            listeControle = gson.fromJson(json,new TypeToken<List<Commande>>() {}.getType());
        }
    }

    public void saveListeDeListeAScanner(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeDeListeAScanner",gson.toJson(listeDeListeAScanner)).apply();
    }

    public void getListeDeListeAScanner(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeDeListeAScanner",null);

        if(json != null){
            listeDeListeAScanner = gson.fromJson(json,new TypeToken<List<List<Produit>>>() {}.getType());
        }
    }

    public void afficheControle(){
        currentControle = listeControle.get(selectedTab - 1);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
        if (currentControle != null){
            date.setText("Date: " + currentControle.getDate());
            num.setText("N°: " + currentControle.getNum());
            nom.setText(currentControle.getNomClient());
            if (currentControle.getQtetotal()>1) {
                qteTotal.setText(String.valueOf(currentControle.getQtetotal()) + " packs");
            } else {
                qteTotal.setText(String.valueOf(currentControle.getQtetotal()) + " pack");
            }
            mAdapter.setListeProduit(currentListeAScanner);
            mAdapter.notifyDataSetChanged();
        }
    }

    public void afficheVide(){
        date.setText("");
        num.setText("");
        nom.setText("Scannez une commande pour faire le contrôle");
        qteTotal.setText("0 pack");
        mAdapter.notifyDataSetChanged();
    }




    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();
//        new GetAllProduitsAsyncTask().execute();
        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeControles();
        saveListeDeListeAScanner();
//         Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList <ScanDataCollection.ScanData> scanData = scanDataCollection.getScanData();
            for(ScanDataCollection.ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        StatusData.ScannerStates state = statusData.getState();
        switch(state) {
            case IDLE:
                statusString = statusData.getFriendlyName()+" is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if(bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if(bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if(!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName()+" is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch(connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
        else {
            bExtScannerDisconnected = false;
            status =  statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            }
            else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            }else{
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

   private void deInitScanner() {
        if (scanner != null) {
            try{
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try{
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

   private void initBarcodeManager(){
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        // Add connection listener
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager(){
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }


    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner==null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while(it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if(scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ControleActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled = checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead(){
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if (currentControle == null){
                        code128 = result;
                        new GetCommandeAsyncTask().execute();
                    }
                    else{
                        produitScanner(result);
                    }
                }
            }
        });
    }


    public int getProduitPos(String result){
        int cpt = 0;
        for (Produit p : currentListeAScanner){
            if (p.getCode128().equals(result)){
                return cpt;
            }
            cpt += 1;
        }
        return cpt;
    }


    public void vider(){
        currentControle = null;
        listeControle.set(selectedTab - 1, null);
        listeDeListeAScanner.set(selectedTab - 1, listeVide);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
        mAdapter.setListeProduit(currentListeAScanner);
        afficheVide();
    }

    public void newControle(View v){
        if (isAllScanned()){
            vider();
        }else{
            DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    switch (which){
                        case DialogInterface.BUTTON_POSITIVE:
                            //No button clicked
                            dialog.dismiss();
                            break;

                        case DialogInterface.BUTTON_NEGATIVE:
                            //Yes button clicked
                            dialog.dismiss();
                            vider();
                            break;
                    }
                }
            };
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage("Tout les produits n'ont pas été scanner voulez-vous vraiment quitter ?");
            builder.setNegativeButton("OUI", dialogClickListener);
            builder.setPositiveButton("NON", dialogClickListener);
            builder.show();
        }
    }


    public void produitScanner(String code128){
        int i = getProduitPos(code128);
        int max = currentListeAScanner.size();
        if (i < max){
            Produit p = currentListeAScanner.get(i);
            if (p.getStock()<1) {
                jouerSon("erreurProduit.mp3");
                Toast.makeText(ControleActivity.this, "Stock épuisé!", Toast.LENGTH_LONG);
            }
            if (p.getNbrScanner() < p.getQte()){
                p.setNbrScanner(p.getNbrScanner() + 1);

                if (isAllScanned() && currentListeAScanner.size() != 0){
                    final Dialog myDialog = new Dialog(this);
                    myDialog.setContentView(R.layout.popup_ok);

                    Button b = myDialog.findViewById(R.id.txt);
                    b.setText("OK");
                    b.setBackground(getDrawable(R.drawable.rounded_corner));
                    b.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            myDialog.dismiss();

                        }
                    });
                    myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    myDialog.show();

                    new UpdateCommandeCompleteAsyncTask().execute();

                }
            }else if (p.getNbrScanner() >= p.getQte()){
                p.setNbrScanner(p.getNbrScanner() + 1);
                afficheCroixRouge();
            }
            afficheControle();
        }else{
            afficheCroixRouge();
        }
    }

    public void afficheCroixRouge(){
        final Dialog myDialog = new Dialog(this);
        myDialog.setContentView(R.layout.popup_ok);
        Button b = myDialog.findViewById(R.id.txt);
        b.setText("X");
        b.setBackground(getDrawable(R.drawable.rounded_corner_x));
        myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        // Hide after some seconds
        final Handler handler  = new Handler();
        final Runnable runnable = new Runnable() {
            @Override
            public void run() {
                if (myDialog.isShowing()) {
                    myDialog.dismiss();
                }
            }
        };

        myDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                handler.removeCallbacks(runnable);
            }
        });
        handler.postDelayed(runnable, 1000);
        jouerSon("erreurProduit.mp3");
        myDialog.show();
    }


    public boolean isAllScanned(){
        int cptScanner = 0;
        int cptTot = 0;
        for (Produit p : currentListeAScanner){
            cptScanner += p.getNbrScanner();
            cptTot += p.getQte();
        }
        return cptTot == cptScanner;
    }


    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }




    //BASE DE DONNES

    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            nom.setText("Récupération de la commande en cours...");

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", code128);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 1){
                        dejaFaite = true;
                    }else{

                        currentControle = new Commande();
                        currentControle.setNum(commande.getString("numero_commande"));
                        currentControle.setNomClient(commande.getString("nom_client"));
                        currentControle.setDate(commande.getString("date_commande"));
                        currentControle.setQtetotal(0);
                        currentControle.setPrixTotal(0);
                        currentControle.setModeLivraison(commande.getString("mode_livraison"));

                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", code128);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                for (int i = 0; i < produits.length(); i++) {
                                    Produit p = new Produit();
                                    JSONObject produit = produits.getJSONObject(i);

                                    try {
                                        p.setRef(produit.getString("reference"));
                                        p.setColoris(produit.getString("coloris"));
                                        p.setCommandable(produit.getString("commandable"));
                                        p.setCode128(produit.getString("code_128"));
                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                        p.setPrix(produit.getDouble("prix"));
                                        p.setStock(produit.getInt("stock"));
                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                        p.setInformations(produit.getString("informations"));
                                        p.setLien_image(produit.getString("lien_image"));
                                        p.setActif(produit.getInt("actif"));
                                        p.setQte(produit.getInt("quantite"));
                                        p.setNbrScanner(0);
                                        produitList.add(p);
                                    }catch (Exception e){
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentControle.setListeProduit(produitList);
                                    listeControle.set(selectedTab - 1, currentControle);

                                    Collections.sort(currentControle.getListeProduit());
                                    listeDeListeAScanner.set(selectedTab - 1, currentControle.getListeProduit());

                                }catch (Exception e){
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentControle == null){
                if (dejaFaite == true){
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(ControleActivity.this);
                    alertDialog.setMessage("Cette commande a déjà été contrôlée.");
                    alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            dialog.dismiss();
                        }
                    });
                    jouerSon("erreurProduit.mp3");
                    alertDialog.show();
                }
                afficheVide();

            }else{
                afficheControle();
            }
        }
    }

    private class UpdateCommandeCompleteAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("numero_commande", currentControle.getNum());
            httpParams2.put("complete", "1");
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "updateCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduits.php", "GET", null);
            List<Produit> produitList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    for (int i = 0; i < produits.length(); i++) {
                        Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);

                        try {
                            p.setRef(produit.getString("reference"));
                            p.setColoris(produit.getString("coloris"));
                            p.setCommandable(produit.getString("commandable"));
                            p.setCode128(produit.getString("code_128"));
                            p.setQuantite_pack(produit.getInt("quantite_packs"));
                            p.setPrix(produit.getDouble("prix"));
                            p.setStock(produit.getInt("stock"));
                            p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                            p.setInformations(produit.getString("informations"));
                            p.setLien_image(produit.getString("lien_image"));
                            p.setActif(produit.getInt("actif"));
                            p.setQte(1);

                            produitList.add(p);

                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }
                    listeAllProduits = produitList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

    void jouerSon(String filename) {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd(filename);
            if (filename != "erreurProduit.mp3") {
                mediaPlayer.setVolume(0.2f,0.2f);
            } else {
                mediaPlayer.setVolume(1.0f,1.0f);
            }
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(mp -> mp.start());
        //Release après lecture
        mediaPlayer.setOnCompletionListener(mp -> {
            if (mp != null) {
                mp.release();
            }
        });
    }

}
