package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.AsyncTask;
import android.view.LayoutInflater;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import fr.itsee.season.CommandesActivity;
import fr.itsee.season.R;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import static fr.itsee.season.CommandesActivity.currentCommande;

public class DialogCommandesActivityEditQte {

    public static void show(final Activity activity, final int position) {
        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);

        View view = inflater.inflate(R.layout.dialog_commande_activity_edit_qte, null);

        final EditText inputField = (EditText) view.findViewById(R.id.dialog_edit_qte_produit_commande);

        //Permet de placer le curseur sur le champ édition et affiche le clavier
        inputField.requestFocus();
        InputMethodManager imm = (InputMethodManager) activity
                .getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.showSoftInput(activity.getCurrentFocus(),
                InputMethodManager.SHOW_FORCED);

        builder.setView(view);

        // add "add" button
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                TextView date, num, prixTotal, nom;
                if (!inputField.getText().toString().equals("")) {
                    if (Integer.parseInt(inputField.getText().toString()) > 0) {
                        final String input = inputField.getText().toString();
                        //Mise à jour de la quantité

                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();

                        httpParams2.put("code_128", currentCommande.getListeProduit().get(position).getCode128());
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                MainActivity.backOfficeURL + "getStockProduit.php", "GET", httpParams2);

                        try {
                            int success = jsonObject2.getInt("success");
                            if (success == 1){
                                JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                                currentCommande.getListeProduit().get(position).setStock(Integer.parseInt(produit.getString("stock")));
                                //Editer la quantité. Si quantité > stock préciser le stock
                                if(Integer.parseInt(input) <= currentCommande.getListeProduit().get(position).getStock()){
                                    currentCommande.getListeProduit().get(position).setQte(Integer.parseInt(input));
                                } else {
                                    currentCommande.getListeProduit().get(position).setQte((Integer.parseInt(produit.getString("stock"))+1));
                                }
                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                        //Rafraichir la liste
                        CommandesActivity.prixTotal.setText(String.valueOf(currentCommande.getPrixTotal()));
                        CommandesActivity.qteTotal.setText(String.valueOf(currentCommande.getQtetotal()) + " packs");
                        CommandesActivity.mAdapter.notifyDataSetChanged();
                        InputMethodManager imm = (InputMethodManager)activity.getSystemService(activity.INPUT_METHOD_SERVICE);
                        imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
                    }
                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
                InputMethodManager imm = (InputMethodManager)activity.getSystemService(activity.INPUT_METHOD_SERVICE);
                imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
            }
        });

        // display add dialog
        builder.show();

    }

}
