package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Build;
import android.support.annotation.RequiresApi;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static fr.itsee.season.CommandesActivity.commandeAImprimer;

public class DialogCommandesActivityListMCCommandes {

    static Activity mActivity;
    private static String code128;
    private Commande commandeVide = new Commande();

    public static void show(final Activity activity, final int position) {
        mActivity = activity;

        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        View view = inflater.inflate(R.layout.dialog_commande_liste_commande_mc, null);

        final Spinner inputField = view.findViewById(R.id.dialog_edit_num_commande);

        builder.setView(view);

        final String BASE_URL = MainActivity.backOfficeURL;
        ArrayList<String> arrayNumeroCommandes = new ArrayList<>();

        //Rafraîchir la liste déroulante des marques
        HttpJsonParser httpJsonParser = new HttpJsonParser();
        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                BASE_URL + "listeNumeroCommandesMCNonImprimee.php", "GET", null);
        try {
            int success = jsonObject.getInt("success");
            JSONArray listeNumeroCommandesMCArray;
            if (success == 1) {
                listeNumeroCommandesMCArray = jsonObject.getJSONArray("data");
                arrayNumeroCommandes.add("--- Choix ---");

                for (int i = 0; i < listeNumeroCommandesMCArray.length(); i++) {

                    JSONObject jsonobject = listeNumeroCommandesMCArray.getJSONObject(i);

                    try {
                        arrayNumeroCommandes.add(jsonobject.getString("numeroCommande"));
                    } catch (Exception e) {
                        e.printStackTrace();
                        Toast.makeText(activity, "Erreur lors de la récupération de la liste des commandes MC"+listeNumeroCommandesMCArray.toString(), Toast.LENGTH_SHORT).show();
                    }
                }

                ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<String>(
                        activity, android.R.layout.simple_spinner_item);
                spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

                Spinner spinnerListeNumeroCommandes = view.findViewById(R.id.dialog_edit_num_commande);
                for (int i = 0; i < arrayNumeroCommandes.size(); i++) {
                    spinnerArrayAdapter.add(arrayNumeroCommandes.get(i) + "\n");
                    spinnerArrayAdapter.notifyDataSetChanged();
                }
                spinnerListeNumeroCommandes.setAdapter(spinnerArrayAdapter);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        // add "add" button
        builder.setPositiveButton("Imprimer", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                TextView date, num, prixTotal, nom;
                if (!inputField.getSelectedItem().toString().equals("")) {

                    final String input = inputField.getSelectedItem().toString();

                    code128 = inputField.getSelectedItem().toString().substring(0,9);
                    try {
                        //Récupérer les informations de la commande
                        final String BASE_URL = MainActivity.backOfficeURL;

                        int success;
                        HttpJsonParser httpJsonParser = new HttpJsonParser();
                        Map<String, String> httpParams = new HashMap<>();
                        httpParams.put("numero_commande", code128);

                        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                                BASE_URL + "getCommandeMC.php", "GET", httpParams);
                        try {
                            success = jsonObject.getInt("success");

                            if (success == 1) {
                                JSONArray commandeArray = jsonObject.getJSONArray("data");
                                JSONObject commande = commandeArray.getJSONObject(0);
                                try {
                                    commandeAImprimer = new Commande();
                                    commandeAImprimer.setNum(commande.getString("numero_commande"));
                                    commandeAImprimer.setNomClient(commande.getString("nom_client"));
                                    commandeAImprimer.setPrenomClient(commande.getString("prenom_client"));
                                    commandeAImprimer.setAdresseClient(commande.getString("adresse_client"));
                                    commandeAImprimer.setCodePostalClient(commande.getString("codepostal_client"));
                                    commandeAImprimer.setVilleClient(commande.getString("ville_client"));
                                    commandeAImprimer.setPaysClient(commande.getString("pays_client"));
                                    commandeAImprimer.setCommentaireClient(commande.getString("commentaire_client"));
                                    commandeAImprimer.setDate(commande.getString("date_commande"));
                                    commandeAImprimer.setModeLivraison(commande.getString("mode_livraison"));
                                    commandeAImprimer.setPrenomClient(commande.getString("prenom_client"));
                                    commandeAImprimer.setWebNomClient(commande.getString("lNom_client"));
                                    commandeAImprimer.setWebPrenomClient(commande.getString("lPrenom_client"));
                                    commandeAImprimer.setWebAdresseClient(commande.getString("lAdresse_client"));
                                    commandeAImprimer.setWebCodePostalClient(commande.getString("lCodePostal_client"));
                                    commandeAImprimer.setWebVilleClient(commande.getString("lVille_client"));
                                    commandeAImprimer.setWebPaysClient(commande.getString("lPays_client"));
                                    commandeAImprimer.setWebCommentaireClient(commande.getString("lCommentaire_client"));
                                    commandeAImprimer.setWebTel1Client(commande.getString("lTelephone_client"));
                                    commandeAImprimer.setWebTel2Client(commande.getString("lTelephone2_client"));
                                    commandeAImprimer.setWebMailClient(commande.getString("lMail_client"));
                                    commandeAImprimer.setWebStatutClient(commande.getString("etat_commande_text_client"));
                                    commandeAImprimer.setRaisonSocialeClient(commande.getString("raisonsociale_client"));
                                    commandeAImprimer.setlRaisonsocialeClient(commande.getString("lRaisonsociale_client"));
                                    commandeAImprimer.setFraisDePortClient(commande.getDouble("fraisdeport_Client"));
                                    commandeAImprimer.setMontantTotalHTPaye(commande.getDouble("montanttotal_ht"));
                                    commandeAImprimer.setTelephoneClient(commande.getString("telephone_client"));
                                    commandeAImprimer.setMCModePaiement(commande.getString("mode_paiement"));
                                }
                                catch (Exception e) {
                                    Toast.makeText(activity, "Erreur de la récupération de la commande MC", Toast.LENGTH_SHORT).show();
                                    e.printStackTrace();
                                }

                                //recuperation des produits de la commande
                                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                                Map<String, String> httpParams2 = new HashMap<>();
                                httpParams2.put("num_commande", commande.getString("numero_commande"));
                                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                        BASE_URL + "listeProduitsCommandeEtMC.php", "GET", httpParams2);

                                List<Produit> produitList = new ArrayList<>();

                                try {
                                    int success2 = jsonObject2.getInt("success");
                                    JSONArray produits;
                                    if (success2 == 1) {
                                        produits = jsonObject2.getJSONArray("data");

                                        //Iterate through the response and populate produits list
                                        for (int i = 0; i < produits.length(); i++) {
                                            Produit p = new Produit();
                                            JSONObject produit = produits.getJSONObject(i);

                                            try {
                                                p.setRef(produit.getString("reference"));
                                                p.setColoris(produit.getString("coloris"));
                                                p.setCommandable(produit.getString("commandable"));
                                                p.setCode128(produit.getString("code_128"));
                                                p.setQuantite_pack(produit.getInt("quantite_packs"));
                                                p.setPrix(produit.getDouble("prix"));
                                                p.setStock(produit.getInt("stock"));
                                                p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                                p.setInformations(produit.getString("informations"));
                                                p.setLien_image(produit.getString("lien_image"));
                                                p.setActif(produit.getInt("actif"));
                                                p.setQte(produit.getInt("quantite"));
                                                p.setNbrScanner(0);
                                                produitList.add(p);
                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }
                                        }

                                        commandeAImprimer.setListeProduit(produitList);
                                    }
                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("numero_commande", code128);

                        //20230603 Passer le ticket comme imprimé uniquement après l'impression
                        //JSONObject jsonObject2 = httpJsonParser.makeHttpRequest(
                        //        BASE_URL + "ticket_deja_imprime_MC.php", "GET", httpParams2);

                        //Lancement de l'impression MC
                        Intent intent = new Intent(mActivity, PrinterMCActivity.class);
                        intent.putExtra("commande", commandeAImprimer);
                        //mActivity.startActivity(intent);
                        mActivity.startActivityForResult(intent, 300);

                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
            }
        });

        // display add dialog
        builder.show();

    }

    @RequiresApi(api = Build.VERSION_CODES.CUPCAKE)
    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", code128);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);

                    //recuperation des produits de la commande
                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();
                    httpParams2.put("num_commande", code128);
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "listeProduitsCommandeEtMC.php", "GET", httpParams2);

                    List<Produit> produitList = new ArrayList<>();

                    try {
                        int success2 = jsonObject2.getInt("success");
                        JSONArray produits;
                        if (success2 == 1) {
                            produits = jsonObject2.getJSONArray("data");
                            //Iterate through the response and populate produits list
                            for (int i = 0; i < produits.length(); i++) {
                                Produit p = new Produit();
                                JSONObject produit = produits.getJSONObject(i);

                                try {
                                    p.setRef(produit.getString("reference"));
                                    p.setColoris(produit.getString("coloris"));
                                    p.setCommandable(produit.getString("commandable"));
                                    p.setCode128(produit.getString("code_128"));
                                    p.setQuantite_pack(produit.getInt("quantite_packs"));
                                    p.setPrix(produit.getDouble("prix"));
                                    p.setStock(produit.getInt("stock"));
                                    p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                    p.setInformations(produit.getString("informations"));
                                    p.setLien_image(produit.getString("lien_image"));
                                    p.setActif(produit.getInt("actif"));
                                    p.setQte(produit.getInt("quantite"));
                                    p.setNbrScanner(0);
                                    produitList.add(p);
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                            try {
                                commandeAImprimer.setListeProduit(produitList);

                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @RequiresApi(api = Build.VERSION_CODES.CUPCAKE)
        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

}
