package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static fr.itsee.season.CommandesActivity.commandeAImprimer;

public class DialogReaActivityList {

    static Activity mActivity;
    private static String dateRea;
    private Commande commandeVide = new Commande();

    public static void show(final Activity activity, final int position) {
        mActivity = activity;

        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        View view = inflater.inflate(R.layout.dialog_rea, null);

        final Spinner inputField = view.findViewById(R.id.dialog_edit_num_commande);

        builder.setView(view);

        final String BASE_URL = MainActivity.backOfficeURL;
        ArrayList<String> arrayNumeroCommandes = new ArrayList<>();

        //Rafraîchir la liste déroulante des marques
        HttpJsonParser httpJsonParser = new HttpJsonParser();
        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                BASE_URL + "liste5DerniersReaTicket.php", "GET", null);
        try {
            int success = jsonObject.getInt("success");
            JSONArray listeNumeroCommandesWebArray;
            if (success == 1) {
                listeNumeroCommandesWebArray = jsonObject.getJSONArray("data");
                arrayNumeroCommandes.add("--- Choix ---");

                for (int i = 0; i < listeNumeroCommandesWebArray.length(); i++) {

                    JSONObject jsonobject = listeNumeroCommandesWebArray.getJSONObject(i);

                    try {
                        arrayNumeroCommandes.add(jsonobject.getString("date"));
                    } catch (Exception e) {
                        e.printStackTrace();
                        Toast.makeText(activity, "Erreur lors de la récupération de la liste des réa", Toast.LENGTH_SHORT).show();
                    }
                }

                ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<String>(
                        activity, android.R.layout.simple_spinner_item);
                spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

                Spinner spinnerListeNumeroCommandes = view.findViewById(R.id.dialog_edit_num_commande);
                for (int i = 0; i < arrayNumeroCommandes.size(); i++) {
                    spinnerArrayAdapter.add(arrayNumeroCommandes.get(i) + "\n");
                    spinnerArrayAdapter.notifyDataSetChanged();
                }
                spinnerListeNumeroCommandes.setAdapter(spinnerArrayAdapter);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        // add "add" button
        builder.setPositiveButton("Imprimer", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                TextView date, num, prixTotal, nom;
                if (!inputField.getSelectedItem().toString().equals("")) {

                    final String input = inputField.getSelectedItem().toString().trim();
                    dateRea = input;
                    HttpJsonParser httpJsonParser = new HttpJsonParser();
                    Map<String, String> httpParams = new HashMap<>();
                    httpParams.put("dateReap", dateRea);
                    JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                            BASE_URL + "listeReaTicket.php", "POST", httpParams);
                    List<Reap> reapList = new ArrayList<>();
                    try {
                        int success = jsonObject.getInt("success");
                        JSONArray reaprovisionnement;
                        if (success == 1) {
                            reaprovisionnement = jsonObject.getJSONArray("data");
                            //Iterate through the response and populate produits list
                            for (int i = 0; i < reaprovisionnement.length(); i++) {
                                Reap r = new Reap();
                                JSONObject reap = reaprovisionnement.getJSONObject(i);

                                try {
                                    r.setRef(reap.getString("reference"));
                                    r.setColoris(reap.getString("coloris"));
                                    r.setQuantite_vendus(reap.getInt("quantite_vendus"));
                                    r.setStock(reap.getInt("stock"));
                                    reapList.add(r);

                                }catch (Exception e){
                                    e.printStackTrace();
                                }

                            }
                            MainActivity.listeReap = reapList;
                            MainActivity.date_reap = inputField.getSelectedItem().toString();

                            Intent intent = new Intent(mActivity, PrinterReaActivity.class);
                            //20230603 - Contrôler si impression
                            //mActivity.startActivity(intent);
                            mActivity.startActivityForResult(intent, 400);

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        Log.d("INFO", "ERREUR"+e);
                    }catch (Exception e){
                        e.printStackTrace();
                        Log.d("INFO", "ERREUR2");
                    }



                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
            }
        });

        // display add dialog
        builder.show();

    }

}