package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Toast;

import java.util.List;

public class MainActivity extends AppCompatActivity {

    public static List<Reap> listeReap;
    public static String date_reap;
    public static Reap currentReap;

    //lien vers inc
//    public static String backOfficeURL = "http://www.season.boutique/inc/";
    public static String backOfficeURL = "http://season.itsee.fr/inc/";

    //a la racine
//    public static String backOfficeURLIMG = "http://www.season.boutique/";
    public static String backOfficeURLIMG = "http://season.itsee.fr/";

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 400) {
            if(resultCode == Activity.RESULT_OK){
            } else if (resultCode == Activity.RESULT_CANCELED) {
                AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Echec d'impression");
                String msg = "Souhaitez-vous relancer ?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                DialogReaActivityList.show(MainActivity.this, 0);
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
            //20230603 - RETOUR IMPRESSION COMMANDE WEB
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Permet d'enlever le bug d'interogation php depuis la fenetre de choix commandes web
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);
        setContentView(R.layout.activity_main);
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        if (netInfo != null && netInfo.isConnectedOrConnecting()) {
            return true;
        } else {
            return false;
        }
    }

    public void commandeButton(View v){
        if (isOnline()){
            Intent intent = new Intent(MainActivity.this, CommandesActivity.class);
            startActivity(intent);
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    public void controleButton(View v){
        if (isOnline()){
            Intent intent = new Intent(MainActivity.this, ControleActivity.class);
            startActivity(intent);
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    public void reapButton(View v){
        if (isOnline()){
            DialogReaActivityList.show(MainActivity.this, 0);
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    public void reserveButton(View v){
        if (isOnline()){
            Intent intent = new Intent(MainActivity.this, ReserveActivity.class);
            startActivity(intent);
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }
}
