package fr.itsee.season;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.icu.text.DecimalFormat;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.epson.epos2.Epos2Exception;
import com.epson.epos2.Log;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.epson.epos2.printer.ReceiveListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PrinterMCActivity extends Activity implements ReceiveListener {

    private Commande commande;

    private static final int REQUEST_PERMISSION = 100;

    private Context mContext = null;
    private EditText mEditTarget = null;
    private Spinner mSpnSeries = null;
    private Spinner mSpnLang = null;
    private Printer mPrinter = null;

    private Button btnSampleReceipt;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_print);

        btnSampleReceipt = findViewById(R.id.btnSampleReceipt);

        mEditTarget = (EditText)findViewById(R.id.edtTarget);


        mEditTarget.setText("TCP:38:9D:92:FB:FD:A8");//SEASON

        btnSampleReceipt.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                updateButtonState(false);
                if (!runPrintReceiptSequence()) {
                    updateButtonState(true);
                }
            }
        });

        requestRuntimePermission();

        mContext = this;

        mSpnSeries = (Spinner)findViewById(R.id.spnModel);
        ArrayAdapter<SpnModelsItem> seriesAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        seriesAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m10), Printer.TM_M10));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m30), Printer.TM_M30));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p20), Printer.TM_P20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60), Printer.TM_P60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60ii), Printer.TM_P60II));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p80), Printer.TM_P80));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t20), Printer.TM_T20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t60), Printer.TM_T60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t70), Printer.TM_T70));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t81), Printer.TM_T81));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t82), Printer.TM_T82));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83), Printer.TM_T83));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83iii), Printer.TM_T83III));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t88), Printer.TM_T88));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90), Printer.TM_T90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90kp), Printer.TM_T90KP));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t100), Printer.TM_T100));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u220), Printer.TM_U220));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u330), Printer.TM_U330));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_l90), Printer.TM_L90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_h6000), Printer.TM_H6000));

        mSpnSeries.setAdapter(seriesAdapter);
        mSpnSeries.setSelection(1);

        mSpnLang = (Spinner)findViewById(R.id.spnLang);
        ArrayAdapter<SpnModelsItem> langAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        langAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        langAdapter.add(new SpnModelsItem(getString(R.string.lang_french), Printer.MODEL_ANK));

        mSpnLang.setAdapter(langAdapter);
        mSpnLang.setSelection(0);


        //try {
        //     Log.setLogSettings(mContext, Log.PERIOD_TEMPORARY, Log.OUTPUT_STORAGE, null, 0, 1, Log.LOGLEVEL_LOW);
        //}
        //catch (Exception e) {
//            ShowMsg.showException(e, "setLogSettings", mContext);
        //}


        Intent intent = getIntent();
        commande = intent.getParcelableExtra("commande");
        Collections.sort(commande.getListeProduit());

        btnSampleReceipt.callOnClick();

        //TCP:38:9D:92:FB:FD:A8

        //Fermer la vue
        finish();
    }

    @Override
    protected void onActivityResult(int requestCode, final int resultCode, final Intent data) {
        if (data != null && resultCode == RESULT_OK) {
            String target = data.getStringExtra(getString(R.string.title_target));
            if (target != null) {
                EditText mEdtTarget = (EditText)findViewById(R.id.edtTarget);
                mEdtTarget.setText(target);
            }
        }
    }

    public void btnDiscovery(View v){
        Intent intent = new Intent(this, DiscoveryActivity.class);
        startActivityForResult(intent, 0);
    }

    public void btnSampleReceipt(View v){
        updateButtonState(false);
        if (!runPrintReceiptSequence()) {
            updateButtonState(true);
        }
    }

    public void btnSampleCoupon(View v){
        updateButtonState(false);
        if (!runPrintCouponSequence()) {
            updateButtonState(true);
        }
    }

    //CHECKER SI NOUVELLES COMMANDES MC
    private class StipulerCommandeMCImprimee extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... strings) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("numero_commande", commande.getNum());
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "ticket_deja_imprime_MC.php", "GET", httpParams1);
            JSONArray cptMCCommandesData;
            try {
                Object success = jsonObject.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }

    }

    private boolean runPrintReceiptSequence() {
        //20230603 - Code retour pour vérifier impression
        Intent returnIntent = new Intent();

        if (!initializeObject()) {
            setResult(Activity.RESULT_CANCELED,returnIntent);
            return false;
        }

        if (!createReceiptData()) {
            finalizeObject();
            setResult(Activity.RESULT_CANCELED,returnIntent);
            return false;
        }

        if (!printData()) {
            finalizeObject();
            setResult(Activity.RESULT_CANCELED,returnIntent);
            return false;
        }

        //Préciser que la commande à été imprimée
        //Mise a jour de l'état de suppression de la commande
        new StipulerCommandeMCImprimee().execute();

        setResult(Activity.RESULT_OK,returnIntent);
        return true;
    }

    public double getPrixTotalRef(String ref){
        double tot = 0;
        for (Produit p : commande.getListeProduit()){
            if (p.getRef().equals(ref)){
                tot += p.getPrix() * p.getQuantite_pack() * p.getQte();
            }
        }
        return tot;
    }

    private boolean createReceiptData() {
        DecimalFormat df = new DecimalFormat("0.00");
        String method = "";
        Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        Bitmap season = BitmapFactory.decodeResource(getResources(), R.drawable.season);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1 - BON TICKET
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            method = "addImage";
            mPrinter.addImage(season, 0, 0, season.getWidth(), season.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("BON DE COMMANDE\n");
            if (!commande.getRaisonsocialeClient().contains("N.C.")) {
                textData.append("CLIENT: " + commande.getRaisonsocialeClient() + "\n");
            } else {
                textData.append("CLIENT: " + commande.getNomClient() + "\n");
            }

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            method = "addBarcode";

            mPrinter.addBarcode("{A" + commande.getNum(), Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");


            textData.append("DATE: " + commande.getDate() + "   N°" + commande.getNum() + "\n");
            textData.append("------------------------------------------------\n");


            textData.append(String.format("%-12s", "REF") + String.format("%-10s", "Qté") + String.format("%-10s", "PU HT") + String.format("%-15s", "MONTANT") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            String oldRef = "";

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());
            Integer cptTotalUnitaire = 0;
            for (Produit p : commande.getListeProduit()) {
                if (oldRef.equals(p.getRef())) {
                    if (p.getStock() - p.getQte() <= 2) {
                        mPrinter.addTextStyle(0, 0, 0, 0);
                        textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                        mPrinter.addText(textData.toString());
                        textData.delete(0, textData.length());
                    } else {
                        mPrinter.addTextStyle(0, 0, 0, 0);
                        textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                        mPrinter.addText(textData.toString());
                        textData.delete(0, textData.length());
                    }
                } else {
                    textData.append("________________________________________________\n");
                    System.out.println(df.format(getPrixTotalRef(p.getRef())));
                    mPrinter.addTextStyle(0, 0, 1, 0);
                    textData.append(String.format("%-12s", p.getRef()) + String.format("%-10s", getQteRef(p.getRef()) + "X" + p.getQuantite_pack() + "pcs") + String.format("%-10s", df.format(p.getPrix())) + String.format("%-15s", df.format(getPrixTotalRef(p.getRef()))) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());

                    if (p.getStock() - p.getQte() <= 2) {
                        mPrinter.addTextStyle(0, 0, 0, 0);
                        textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                        mPrinter.addText(textData.toString());
                        textData.delete(0, textData.length());
                    } else {
                        mPrinter.addTextStyle(0, 0, 0, 0);
                        textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                        mPrinter.addText(textData.toString());
                        textData.delete(0, textData.length());
                    }
                }
                oldRef = p.getRef();
                cptTotalUnitaire += (p.getQte()*p.getQuantite_pack());
            }


            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);
            textData.append("------------------------------------------------\n");
            //textData.append(String.format("%-21s", "Qté TOTAL: " + commande.getQtetotal()+" / "+cptTotalUnitaire+"Pcs") + String.format("%27s", "TOTAL HT: " + df.format(commande.getPrixTotal())) + "\n");
            textData.append("Qté TOTAL: " + commande.getQtetotal() + " / " + cptTotalUnitaire + "Pcs\n");
            textData.append("------------------------------------------------\n");
            textData.append("TOTAL HT: " + df.format(commande.getPrixTotal()) + "\n");
            //textData.append(String.format("%48s", "FRAIS DE PORT: " + df.format((commande.getFraisDePortClient()/1.2))) + "\n");
            textData.append("FRAIS DE PORT: " + df.format(commande.getFraisDePortClient()) + "\n");
            //textData.append(String.format("%48s", "TOTAL HT AVEC FDP: " + df.format((commande.getPrixTotal()+(commande.getFraisDePortClient()/1.2)))) + "\n");
            textData.append("TOTAL HT AVEC FDP: " + df.format((commande.getPrixTotal()+commande.getFraisDePortClient())) + "\n");
            textData.append("\n");
            textData.append("TOTAL TTC: " + df.format(((commande.getPrixTotal()+commande.getFraisDePortClient())*1.2)) + "\n");
            textData.append("\n");
            textData.append("TRANSPORTEUR: " + commande.getModeLivraison() + "\n");
            textData.append("\n");
            textData.append("MODE DE PAIEMENT: " + commande.getMCModePaiement() + "\n");
            method = "addText";
            if (commande.getMontantTotalHTPaye() != (commande.getPrixTotal()+commande.getFraisDePortClient())) {
                textData.append("! COMMANDE A CONTROLER !");
                textData.append("\n\n");
            } else {
                textData.append("VERIFIE");
                textData.append("\n\n");
            }
            //Si ne contient pas N.C.

            //FACTURATION
            //20230604 - Non demandé pour le ticket MC
            /*textData.append("COORDONNÉES DE FACTURATION:");
            textData.append("\n");
            if (!commande.getWebStatutClient().contains("N.C.")) {
                textData.append(commande.getWebStatutClient());
                textData.append("\n");
            }
            if (!commande.getRaisonsocialeClient().contains("N.C.")) {
                textData.append(commande.getRaisonsocialeClient());
                textData.append("\n");
            }
            if (!commande.getNomClient().contains("N.C.")) {
                textData.append(commande.getNomClient());
                textData.append("\n");
            }
            if (!commande.getPrenomClient().contains("N.C.")) {
                textData.append(commande.getPrenomClient());
                textData.append("\n");
            }
            if (!commande.getAdresseClient().contains("N.C.")) {
                textData.append(commande.getAdresseClient());
                textData.append("\n");
            }
            if (!commande.getCodePostalClient().contains("N.C.")) {
                textData.append(commande.getCodePostalClient());
                textData.append("\n");
            }
            if (!commande.getVilleClient().contains("N.C.")) {
                textData.append(commande.getVilleClient());
                textData.append("\n");
            }
            if (!commande.getPaysClient().contains("N.C.")) {
                textData.append(commande.getPaysClient());
                textData.append("\n");
            }
            if (!commande.getTelephoneClient().contains("N.C.")) {
                textData.append(commande.getTelephoneClient());
                textData.append("\n");
            }

            textData.append("\n");
            textData.append("\n");
*/
            //LIVRAISON
            textData.append("COORDONNÉES DE LIVRAISON:");
            textData.append("\n");
            if (!commande.getLRaisonsocialeClient().contains("N.C.")) {
                textData.append(commande.getLRaisonsocialeClient());
                textData.append("\n");
            } else if (!commande.getRaisonsocialeClient().contains("N.C.")) {
                textData.append(commande.getRaisonsocialeClient());
                textData.append("\n");
            }
            if (!commande.getNomClient().contains("N.C.")) {
                textData.append(commande.getWebNomClient());
                textData.append("\n");
            }
            if (!commande.getWebPrenomClient().contains("N.C.")) {
                textData.append(commande.getWebPrenomClient());
                textData.append("\n");
            }
            if (!commande.getWebAdresseClient().contains("N.C.")) {
                textData.append(commande.getWebAdresseClient());
                textData.append("\n");
            }
            if (!commande.getWebCodePostalClient().contains("N.C.")) {
                textData.append(commande.getWebCodePostalClient());
                textData.append("\n");
            }
            if (!commande.getWebVilleClient().contains("N.C.")) {
                textData.append(commande.getWebVilleClient());
                textData.append("\n");
            }
            if (!commande.getWebPaysClient().contains("N.C.")) {
                textData.append(commande.getWebPaysClient());
                textData.append("\n");
            }
            if (!commande.getWebTel1Client().contains("N.C.")) {
                textData.append(commande.getWebTel1Client());
                textData.append("\n");
            }
            if (!commande.getWebTel2Client().contains("N.C.")) {
                textData.append(commande.getWebTel2Client());
                textData.append("\n");
            }
            if (!commande.getWebMailClient().contains("N.C.")) {
                textData.append(commande.getWebMailClient());
                textData.append("\n");
            }

            textData.append("\n");
            textData.append("\n");

            //Commentaires
            if (!commande.getCommentaireClient().contains("N.C.")) {
                textData.append("\n\nCOMMENTAIRE:\n");
                textData.append(commande.getCommentaireClient());
            }
            if (!commande.getWebCommentaireClient().contains("N.C.")) {
                textData.append("\n\nCOMMENTAIRE LIVRAISON:\n");
                textData.append(commande.getWebCommentaireClient());
            }

            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
//            ShowMsg.showException(e, method, mContext);
            return false;
        }
        textData = null;
        return true;
    }


    public int getQteRef(String ref){
        int res = 0;
        for (Produit p : commande.getListeProduit()){
            if (p.getRef().equals(ref)){
                res += p.getQte();
            }
        }
        return res;
    }

    private boolean runPrintCouponSequence() {
        if (!initializeObject()) {
            return false;
        }

        if (!createCouponData()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean createCouponData() {
        String method = "";
        Bitmap coffeeData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        Bitmap wmarkData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);

        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 110;
        final int barcodeHeightPos = 70;

        if (mPrinter == null) {
            return false;
        }

        try {
            method = "addPageBegin";
            mPrinter.addPageBegin();

            method = "addPageArea";
            mPrinter.addPageArea(0, 0, pageAreaWidth, pageAreaHeight);

            method = "addPageDirection";
            mPrinter.addPageDirection(Printer.DIRECTION_TOP_TO_BOTTOM);

            method = "addPagePosition";
            mPrinter.addPagePosition(0, coffeeData.getHeight());

            method = "addImage";
            mPrinter.addImage(coffeeData, 0, 0, coffeeData.getWidth(), coffeeData.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            method = "addPagePosition";
            mPrinter.addPagePosition(0, wmarkData.getHeight());

            method = "addImage";
            mPrinter.addImage(wmarkData, 0, 0, wmarkData.getWidth(), wmarkData.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT);

            method = "addPagePosition";
            mPrinter.addPagePosition(fontAWidth * 4, (pageAreaHeight / 2) - (fontAHeight * 2));

            method = "addTextSize";
            mPrinter.addTextSize(3, 3);

            method = "addTextStyle";
            mPrinter.addTextStyle(Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.TRUE, Printer.PARAM_DEFAULT);

            method = "addTextSmooth";
            mPrinter.addTextSmooth(Printer.TRUE);

            method = "addText";
            mPrinter.addText("FREE Coffee\n");

            method = "addPagePosition";
            mPrinter.addPagePosition((pageAreaWidth / barcodeWidth) - barcodeWidthPos, coffeeData.getHeight() + barcodeHeightPos);

            method = "addBarcode";
            mPrinter.addBarcode("01234567890", Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, barcodeWidth, barcodeHeight);

            method = "addPageEnd";
            mPrinter.addPageEnd();

            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
        }
        catch (Exception e) {
//            ShowMsg.showException(e, method, mContext);
            return false;
        }

        return true;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            Toast.makeText(this, "Imprimante hors ligne !", Toast.LENGTH_SHORT).show();
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
//            ShowMsg.showMsg(makeErrorMessage(status), mContext);
            if (makeErrorMessage(status) != "") {
                Toast.makeText(this, makeErrorMessage(status), Toast.LENGTH_SHORT).show();
            }
            try {
                mPrinter.disconnect();
            }
            catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        try {
            mPrinter.sendData(Printer.PARAM_DEFAULT);

        }
        catch (Exception e) {
//            ShowMsg.showException(e, "sendData", mContext);
            try {
                mPrinter.disconnect();
            }
            catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            mPrinter = new Printer(((SpnModelsItem) mSpnSeries.getSelectedItem()).getModelConstant(),
                    ((SpnModelsItem) mSpnLang.getSelectedItem()).getModelConstant(),
                    mContext);
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "Printer", mContext);
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            mPrinter.connect(mEditTarget.getText().toString(), Printer.PARAM_DEFAULT);
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "connect", mContext);
            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "beginTransaction", mContext);
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            }
            catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        }
        catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "endTransaction", mContext);
                }
            });
        }

        try {
            mPrinter.disconnect();
        }
        catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "disconnect", mContext);
                }
            });
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == Printer.FALSE) {
            return false;
        }
        else if (status.getOnline() == Printer.FALSE) {
            return false;
        }
        else {
            //print available
        }

        return true;
    }

    private String makeErrorMessage(PrinterStatusInfo status) {
        String msg = "";

        //if (status.getOnline() == Printer.FALSE) {
        //    msg += getString(R.string.handlingmsg_err_offline);
        //}
        if (status.getConnection() == Printer.FALSE) {
            msg += getString(R.string.handlingmsg_err_no_response);
        }
        if (status.getCoverOpen() == Printer.TRUE) {
            msg += getString(R.string.handlingmsg_err_cover_open);
        }
        if (status.getPaper() == Printer.PAPER_EMPTY) {
            msg += getString(R.string.handlingmsg_err_receipt_end);
        }
        if (status.getPaperFeed() == Printer.TRUE || status.getPanelSwitch() == Printer.SWITCH_ON) {
            msg += getString(R.string.handlingmsg_err_paper_feed);
        }
        if (status.getErrorStatus() == Printer.MECHANICAL_ERR || status.getErrorStatus() == Printer.AUTOCUTTER_ERR) {
            msg += getString(R.string.handlingmsg_err_autocutter);
            msg += getString(R.string.handlingmsg_err_need_recover);
        }
        if (status.getErrorStatus() == Printer.UNRECOVER_ERR) {
            msg += getString(R.string.handlingmsg_err_unrecover);
        }
        if (status.getErrorStatus() == Printer.AUTORECOVER_ERR) {
            if (status.getAutoRecoverError() == Printer.HEAD_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_head);
            }
            if (status.getAutoRecoverError() == Printer.MOTOR_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_motor);
            }
            if (status.getAutoRecoverError() == Printer.BATTERY_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_battery);
            }
            if (status.getAutoRecoverError() == Printer.WRONG_PAPER) {
                msg += getString(R.string.handlingmsg_err_wrong_paper);
            }
        }
        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_0) {
            msg += getString(R.string.handlingmsg_err_battery_real_end);
        }

        return msg;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {
        EditText edtWarnings = (EditText)findViewById(R.id.edtWarnings);
        String warningsMsg = "";

        if (status == null) {
            return;
        }

        if (status.getPaper() == Printer.PAPER_NEAR_END) {
            warningsMsg += getString(R.string.handlingmsg_warn_receipt_near_end);
        }

        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_1) {
            warningsMsg += getString(R.string.handlingmsg_warn_battery_near_end);
        }

        edtWarnings.setText(warningsMsg);
    }

    private void updateButtonState(boolean state) {
        Button btnReceipt = (Button)findViewById(R.id.btnSampleReceipt);
        Button btnCoupon = (Button)findViewById(R.id.btnSampleCoupon);
        btnReceipt.setEnabled(state);
        btnCoupon.setEnabled(state);
    }

    @Override
    public void onPtrReceive(final Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {
                //ShowMsg.showResult(code, makeErrorMessage(status), mContext);

                dispPrinterWarnings(status);

                updateButtonState(true);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private void requestRuntimePermission() {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            return;
        }

        int permissionStorage = ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
        int permissionLocation = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION);

        List<String> requestPermissions = new ArrayList<>();

        if (permissionStorage == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }
        if (permissionLocation == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String permissions[], @NonNull int[] grantResults) {
        if (requestCode != REQUEST_PERMISSION || grantResults.length == 0) {
            return;
        }

        List<String> requestPermissions = new ArrayList<>();

        for (int i = 0; i < permissions.length; i++) {
            if (permissions[i].equals(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
            if (permissions[i].equals(Manifest.permission.ACCESS_COARSE_LOCATION)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }
}