package fr.itsee.season;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.icu.text.DecimalFormat;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.epson.epos2.Epos2Exception;
import com.epson.epos2.Log;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.epson.epos2.printer.ReceiveListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PrinterReaActivityBackup extends Activity implements ReceiveListener {

    private static final int REQUEST_PERMISSION = 100;

    private Context mContext = null;
    private EditText mEditTarget = null;
    private Spinner mSpnSeries = null;
    private Spinner mSpnLang = null;
    private Printer mPrinter = null;

    private Button btnSampleReceipt;

    private TextView impressionEcran;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_print);

        btnSampleReceipt = findViewById(R.id.btnSampleReceipt);

        mEditTarget = (EditText)findViewById(R.id.edtTarget);

        btnSampleReceipt.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //TEST
                /*if (imprimerTicketReapLOG()) {
                    Toast.makeText(PrinterReaActivityBackup.this, "Impression du réa...", Toast.LENGTH_SHORT).show();
                }*/

                //PROD
                if (!runPrintReceiptSequence()) {
                    Toast.makeText(PrinterReaActivityBackup.this, "Impression du réa...", Toast.LENGTH_SHORT).show();
                }
            }
        });

        impressionEcran = findViewById(R.id.impressionEcran);

        requestRuntimePermission();

        mContext = this;

        mSpnSeries = (Spinner)findViewById(R.id.spnModel);
        ArrayAdapter<SpnModelsItem> seriesAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        seriesAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m10), Printer.TM_M10));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m30), Printer.TM_M30));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p20), Printer.TM_P20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60), Printer.TM_P60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60ii), Printer.TM_P60II));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p80), Printer.TM_P80));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t20), Printer.TM_T20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t60), Printer.TM_T60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t70), Printer.TM_T70));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t81), Printer.TM_T81));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t82), Printer.TM_T82));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83), Printer.TM_T83));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83iii), Printer.TM_T83III));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t88), Printer.TM_T88));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90), Printer.TM_T90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90kp), Printer.TM_T90KP));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t100), Printer.TM_T100));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u220), Printer.TM_U220));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u330), Printer.TM_U330));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_l90), Printer.TM_L90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_h6000), Printer.TM_H6000));

        mSpnSeries.setAdapter(seriesAdapter);
        mSpnSeries.setSelection(1);

        mSpnLang = (Spinner)findViewById(R.id.spnLang);
        ArrayAdapter<SpnModelsItem> langAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        langAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        langAdapter.add(new SpnModelsItem(getString(R.string.lang_french), Printer.MODEL_ANK));

        mSpnLang.setAdapter(langAdapter);
        mSpnLang.setSelection(0);

        //Lancement de l'impression REA
        btnSampleReceipt.callOnClick();

        //TCP:38:9D:92:FB:FD:A8

        //Fermer la vue //PROD
        finish();
    }



    @Override
    protected void onActivityResult(int requestCode, final int resultCode, final Intent data) {
        if (data != null && resultCode == RESULT_OK) {
            String target = data.getStringExtra(getString(R.string.title_target));
            if (target != null) {
                EditText mEdtTarget = (EditText)findViewById(R.id.edtTarget);
                mEdtTarget.setText(target);
            }
        }
    }

    public void btnDiscovery(View v){
        Intent intent = new Intent(this, DiscoveryActivity.class);
        startActivityForResult(intent, 0);
    }

    //CHECKER SI NOUVELLES COMMANDES WEB
    private class StipulerReapImprime extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... strings) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            //httpParams1.put("numero_commande", commande.getNum());
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "remiseZeroReassort.php", "GET", httpParams1);
            try {
                Object success = jsonObject.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }

    }

    private boolean runPrintReceiptSequence() {
        if (!initializeObject()) {
            return false;
        }

        if (!imprimerTicketReap()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        //Si ticket imprimé
        //Remise à zéro du réap LANCE APRES IMPRESSION
        new StipulerReapImprime().execute();

        return true;
    }

    private boolean imprimerTicketReap() {
        String method = "";
        //Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        /*Bitmap season = BitmapFactory.decodeResource(getResources(), R.drawable.season);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;
*/

        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1 - REAP
            //TICKET 1 - BON TICKET
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            method = "addImage";
            Bitmap season = BitmapFactory.decodeResource(getResources(), R.drawable.season);
            mPrinter.addImage(season, 0, 0, season.getWidth(), season.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);


            if (MainActivity.date_reap.contains("Dernier")) {
                SimpleDateFormat df = new SimpleDateFormat("dd-MM-yyyy");
                Calendar c = Calendar.getInstance();
                String date = df.format(c.getTime());
                textData.append("\nDATE: " + date +  " (Dernier)\n");
            } else {
                String dateY = MainActivity.date_reap;
                String dateM = MainActivity.date_reap;
                String dateD = MainActivity.date_reap;
                dateY = dateY.substring(0,4);
                dateM = dateM.substring(5,7);
                dateD = dateD.substring(8,10);

                textData.append("\nDATE: " + dateD+"-"+dateM+"-"+dateY.substring(0,4) + "\n");
            }

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            textData.append("------------------------------------------------\n\n");

            //textData.append(String.format("%-12s", "REF") + String.format("%-10s", "COLORIS") + String.format("%-10s", "QTE") + String.format("%-15s", "Stock") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            textData.append(String.format("%-16s", "REF.") + String.format("%-16s", "COLORIS") + String.format("%-8s", "QTE") + String.format("%-6s", "STOCK") + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            textData.append("________________________________________________\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            //Parcours de chaque produit reap en mode ligne
            for (Reap r : MainActivity.listeReap) {
                //REF, COLORIS, QTE
                mPrinter.addTextSize(2, 2); //DOUBLE
                mPrinter.addTextStyle(0, 0, 1, 0);
                textData.append(String.format("%-8s", r.getRef()) + String.format("%-8s", r.getColoris()) + String.format("%-4s", r.getQuantite_vendus()));
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
                //STOCK
                mPrinter.addTextSize(1, 1); //SIMPLE
                textData.append(String.format("%-6s", r.getStock()) + "\n");
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
                //FIN LIGNE
                textData.append("________________________________________________\n");
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
            }

            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());

            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
//            ShowMsg.showException(e, method, mContext);
            return false;
        }
        textData = null;
        return true;
    }

    private boolean imprimerTicketReapLOG() {
        String method = "";
        //Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();

        String listeReapTxt = "";

        try {

            //TICKET 1 - REASSORT
            if (MainActivity.date_reap.contains("Dernier")) {
                SimpleDateFormat df = new SimpleDateFormat("dd-MM-yyyy");
                Calendar c = Calendar.getInstance();
                String date = df.format(c.getTime());
                textData.append("\nDATE: " + date +  " (Dernier)\n");
            } else {
                String dateY = MainActivity.date_reap;
                String dateM = MainActivity.date_reap;
                String dateD = MainActivity.date_reap;
                dateY = dateY.substring(0,4);
                dateM = dateM.substring(5,7);
                dateD = dateD.substring(8,10);

                textData.append("\nDATE: " + dateD+"-"+dateM+"-"+dateY.substring(0,4) + "\n");
            }

            textData.append("------------------------------------------------\n\n");
            listeReapTxt += textData;
            //textData.append(String.format("%-12s", "REF") + String.format("%-10s", "COLORIS") + String.format("%-10s", "QTE") + String.format("%-15s", "Stock") + "\n");
            //Toast.makeText(this, textData, Toast.LENGTH_LONG);
            //listeReapTxt += textData;
            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            textData.delete(0, textData.length());

            //Parcours de chaque produit reap en mode ligne
            for (Reap r : MainActivity.listeReap) {
                textData.append(String.format("%-5s", "") + String.format("%-7s", r.getRef()) + String.format("%-7s", r.getColoris()) + String.format("%-4s", r.getQuantite_vendus()) + String.format("%-3s", r.getStock()) + "\n");
                Toast.makeText(this, textData, Toast.LENGTH_LONG);
                textData.append("________________________________________________\n");
                listeReapTxt += textData;
                textData.delete(0, textData.length());

            }

            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");

            method = "addCut";
            textData.delete(0, textData.length());

            impressionEcran.setText(listeReapTxt);

        } catch (Exception e) {
//            ShowMsg.showException(e, method, mContext);
            impressionEcran.setText("ERREUR !!!!"+e);
            return false;
        }
        textData = null;

        //Si ticket imprimé
        //20230603 - Remise à zéro du réap uniquement si ticket imprimé
        //if (MainActivity.date_reap.trim().equals("-Dernier- ") || MainActivity.date_reap.trim().equals("-Dernier-") || MainActivity.date_reap.trim().equals("Dernier")) {
        //    new StipulerReapImprime().execute();
        //}

        return true;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            Toast.makeText(this, "Imprimante hors ligne !", Toast.LENGTH_SHORT).show();
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
//            ShowMsg.showMsg(makeErrorMessage(status), mContext);
            if (makeErrorMessage(status) != "") {
                Toast.makeText(this, makeErrorMessage(status), Toast.LENGTH_SHORT).show();
            }
            try {
                mPrinter.disconnect();
            }
            catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        try {
            mPrinter.sendData(Printer.PARAM_DEFAULT);

        }
        catch (Exception e) {
//            ShowMsg.showException(e, "sendData", mContext);
            try {
                mPrinter.disconnect();
            }
            catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            mPrinter = new Printer(((SpnModelsItem) mSpnSeries.getSelectedItem()).getModelConstant(),
                    ((SpnModelsItem) mSpnLang.getSelectedItem()).getModelConstant(),
                    mContext);
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "Printer", mContext);
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            mPrinter.connect("TCP:38:9D:92:FD:4B:30", Printer.PARAM_DEFAULT); //CHANGEMENT DE LA MAC POUR REAP
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "connect", mContext);
            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        }
        catch (Exception e) {
//            ShowMsg.showException(e, "beginTransaction", mContext);
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            }
            catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        }
        catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "endTransaction", mContext);
                }
            });
        }

        try {
            mPrinter.disconnect();
        }
        catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "disconnect", mContext);
                }
            });
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == Printer.FALSE) {
            return false;
        }
        else if (status.getOnline() == Printer.FALSE) {
            return false;
        }
        else {
            //print available
        }

        return true;
    }

    private String makeErrorMessage(PrinterStatusInfo status) {
        String msg = "";

        //if (status.getOnline() == Printer.FALSE) {
        //    msg += getString(R.string.handlingmsg_err_offline);
        //}
        if (status.getConnection() == Printer.FALSE) {
            msg += getString(R.string.handlingmsg_err_no_response);
        }
        if (status.getCoverOpen() == Printer.TRUE) {
            msg += getString(R.string.handlingmsg_err_cover_open);
        }
        if (status.getPaper() == Printer.PAPER_EMPTY) {
            msg += getString(R.string.handlingmsg_err_receipt_end);
        }
        if (status.getPaperFeed() == Printer.TRUE || status.getPanelSwitch() == Printer.SWITCH_ON) {
            msg += getString(R.string.handlingmsg_err_paper_feed);
        }
        if (status.getErrorStatus() == Printer.MECHANICAL_ERR || status.getErrorStatus() == Printer.AUTOCUTTER_ERR) {
            msg += getString(R.string.handlingmsg_err_autocutter);
            msg += getString(R.string.handlingmsg_err_need_recover);
        }
        if (status.getErrorStatus() == Printer.UNRECOVER_ERR) {
            msg += getString(R.string.handlingmsg_err_unrecover);
        }
        if (status.getErrorStatus() == Printer.AUTORECOVER_ERR) {
            if (status.getAutoRecoverError() == Printer.HEAD_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_head);
            }
            if (status.getAutoRecoverError() == Printer.MOTOR_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_motor);
            }
            if (status.getAutoRecoverError() == Printer.BATTERY_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_battery);
            }
            if (status.getAutoRecoverError() == Printer.WRONG_PAPER) {
                msg += getString(R.string.handlingmsg_err_wrong_paper);
            }
        }
        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_0) {
            msg += getString(R.string.handlingmsg_err_battery_real_end);
        }

        return msg;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {
        EditText edtWarnings = (EditText)findViewById(R.id.edtWarnings);
        String warningsMsg = "";

        if (status == null) {
            return;
        }

        if (status.getPaper() == Printer.PAPER_NEAR_END) {
            warningsMsg += getString(R.string.handlingmsg_warn_receipt_near_end);
        }

        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_1) {
            warningsMsg += getString(R.string.handlingmsg_warn_battery_near_end);
        }

        edtWarnings.setText(warningsMsg);
    }

    @Override
    public void onPtrReceive(final Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {
                //ShowMsg.showResult(code, makeErrorMessage(status), mContext);

                dispPrinterWarnings(status);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private void requestRuntimePermission() {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            return;
        }

        int permissionStorage = ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
        int permissionLocation = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION);

        List<String> requestPermissions = new ArrayList<>();

        if (permissionStorage == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }
        if (permissionLocation == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String permissions[], @NonNull int[] grantResults) {
        if (requestCode != REQUEST_PERMISSION || grantResults.length == 0) {
            return;
        }

        List<String> requestPermissions = new ArrayList<>();

        for (int i = 0; i < permissions.length; i++) {
            if (permissions[i].equals(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
            if (permissions[i].equals(Manifest.permission.ACCESS_COARSE_LOCATION)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }
}