package fr.itsee.season;

import android.os.Parcel;
import android.os.Parcelable;

public class Transporteur implements Parcelable, Comparable<Transporteur> {

    private String nom;
    private double prix;

    public Transporteur(){

    }

    public Transporteur(Transporteur t){
        this.nom = t.getNom();
        this.prix = t.getPrix();
    }


    protected Transporteur(Parcel in) {
        nom = in.readString();
        prix = in.readDouble();
    }

    public static final Creator<Transporteur> CREATOR = new Creator<Transporteur>() {
        @Override
        public Transporteur createFromParcel(Parcel in) {
            return new Transporteur(in);
        }

        @Override
        public Transporteur[] newArray(int size) {
            return new Transporteur[size];
        }
    };

    @Override
    public int compareTo(Transporteur transporteur) {
        return this.getNom().compareTo(transporteur.getNom());
    }

    public String getNom() {
        return nom;
    }

    public double getPrix() {
        return prix;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public void setPrix(double prix) {
        this.prix = prix;
    }

    @Override
    public String toString() {
        return "" + nom + ": " + prix + "€ HT";
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(nom);
        parcel.writeDouble(prix);
    }
}